// WinWolDlg.cpp : t@C
//

#include "stdafx.h"
#include "WinWol.h"
#include "WinWolDlg.h"
#include "afxdialogex.h"
#include "GlobalFunc.h"
#include "HostEditDlg.h"
#include "GetIpDlg.h"
#include "GetMacAddrDlg.h"
#include "GetHostDlg.h"
#include "OptionDlg.h"
#include "SendIcmpDlg.h"
#include "CollectHostDlg.h"
#include "util.h"
#include <Winver.h>
#include <process.h>

#pragma comment(lib, "Version.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Xe[^Xo[ɕ\邽
static UINT idArray[] = { ID_SEPARATOR };

// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


BOOL CAboutDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  ɏǉĂ
	WORD		wVer[4];
	TCHAR		buf[1024];
	CString		sValue;

	GetVersionInfo(buf, sizeof(buf)/sizeof(buf[0]), "ProductName");

	if (GetVersionVal(&wVer[0], &wVer[1], &wVer[2], &wVer[3])) {
		sValue.Format("%s Ver.%u.%02u", buf, wVer[0], wVer[1]);
	} else {
		sValue = buf;
	}
	GetDlgItem(IDC_STATIC_VERSION)->SetWindowText(sValue);

	if (GetCopyrightStr(buf, sizeof(buf))) {
		GetDlgItem(IDC_STATIC_COPYRIGHT)->SetWindowText(buf);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


// CWinWolDlg _CAO


CWinWolDlg::CWinWolDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CWinWolDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_Accel = LoadAccelerators(NULL, MAKEINTRESOURCE(IDR_ACCELERATOR1));

	m_bInited = FALSE;

	m_TimeOut = ICMP_ECHO_TIME_OUT;
	m_CollectHostTimeOut = COLLECT_HOST_TIME_OUT;
	m_PortNo = DEFAULT_PORT_NUMBER;
	m_MaxHostNum = DFLT_MAX_HOST_NUM;

	m_bInitRefresh = TRUE;
	m_bNoExternCmd = FALSE;
	m_bCheckNetworkSegment = FALSE;
	m_bAutoRefresh = TRUE;
	m_bEnableRemoteShutdown = FALSE;

	m_TimerInterval = DFLT_TIMER_INTERVAL;
	m_ActiveFgColor = RGB(0, 0, 0);
	m_ActiveBgColor = RGB(0, 255, 0);
	m_ActiveImgMaskColor = RGB(0, 0, 255);
	m_sAvtiveMark = DEFAULT_ACTIVE_MARK;
	m_nActiveMarkType = ACTIVE_MARK_TYPE_ICON;

	m_TimerID = 0;
	m_RefreshTimerID = 0;
	m_TipTimerID = 0;

	m_nTipTimeOut = 0;

	m_hWorkEvent = NULL;
	m_hWorkThread = NULL;
	m_bWorkActive = FALSE;

	m_ListRowHeight = LIST_ROW_HEIGHT;

	m_SelHostName = "";
	m_SelComment = "";
	m_SelMacAddr = "";
	m_SelIpAddr = "";
	m_SelNetMask = "";

	m_nCursorType = WOL_CURSOR_TYPE_NORMAL;
	m_hCollectThread = NULL;
	m_hCollectEvent = NULL;
	m_pCollectProcDlg = NULL;

	m_sCollectHostStart = "";
	m_sCollectHostEnd = "";
	m_sCollectHostNetMask = "";

	m_dwCollectStartAddr = 0;
	m_dwCollectEndAddr = 0;
	m_dwCollectNetMask = 0;
	m_dwCollectCurrentAddr = 0;
	m_nCollectDetectCount = 0;
	m_bCollectActive = FALSE;

	memset(&m_csCollect, 0, sizeof(m_csCollect));
	memset(&m_csRefresh, 0, sizeof(m_csRefresh));
	memset(&m_csListItem, 0, sizeof(m_csListItem));

	m_HostArray.RemoveAll();
}

//Xe[^Xo[ɃbZ[W\
void	CWinWolDlg::DispStatusMsg(LPCTSTR lpMsg)
{
	m_wndStatusBar.GetStatusBarCtrl().SetText(lpMsg, 255, 0);
}

//j[獀ڂ̈ʒu擾
int	 CWinWolDlg::SearchMenuPos(CMenu *pMenu, UINT nID)
{
	UINT	id;
	int		count;
	int		i, idx;
		
	//j[獀ڂ̈ʒu擾
	count = pMenu->GetMenuItemCount();
	idx = -1;
	for (i = 0; i < count; i++) {
		id = pMenu->GetMenuItemID(i);
		if (id == nID) {
			idx = i;
			break;
		}
	}
	return idx;
}

//c[o[̕\XV
void	CWinWolDlg::ToolBarItemEnable()
{
	int	count;

	if ((count = m_ListHosts.GetSelectedCount()) > 0) {
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_INSERT, TRUE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_EDIT, TRUE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_DELETE, TRUE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_CUT, TRUE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_COPY, TRUE);
		if (count == 1) {
			m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_UP, TRUE);
			m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_DOWN, TRUE);
		} else {
			m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_UP, FALSE);
			m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_DOWN, FALSE);
		}
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_VIEW_CHECK, TRUE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_TOOL_SEND, TRUE);
	} else {
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_INSERT, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_EDIT, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_DELETE, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_CUT, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_COPY, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_UP, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_EDIT_DOWN, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_VIEW_CHECK, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_TOOL_SEND, FALSE);
	}
	if (m_RefreshTimerID) {
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_VIEW_PERIOD_START, FALSE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_VIEW_PERIOD_STOP, TRUE);
	} else {
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_VIEW_PERIOD_START, TRUE);
		m_wndToolBar.GetToolBarCtrl().EnableButton(ID_VIEW_PERIOD_STOP, FALSE);
	}
}

// }WbNEpPbgM
int	CWinWolDlg::SendMagicPacket(LPCTSTR sIpAddr, LPCTSTR sNetMask,
								LPCTSTR sMacAddr, BOOL bBloadcast/*=TRUE*/)
{
	CString	str;
	int		res = 0;

	if ((res = ::SendWakeupPacket(sIpAddr, sNetMask, sMacAddr,
									bBloadcast, (u_short)m_PortNo)) != 0) {
		if (res == -1) {
			// IPAhXZbgĂ܂
			str.LoadString(IDS_STRING_IP_ADDRESS_NOT_SET);
			MessageBox(str);
		} else if (res == -2) {
			// sMACAhX
			str.LoadString(IDS_STRING_ILLEGAL_MAC_ADDRESS);
			MessageBox(str);
		} else {
			str.Format("sendto(): %s", GetErrorString(WSAGetLastError()));
			MessageBox(str);
		}
	}
	return res;
}

BOOL	CWinWolDlg::SendIcmpPacket(LPCTSTR sHost)
{
	DWORD	dwErr;
	SOCKET	sock = INVALID_SOCKET;
	int		ret;
	
	if (m_bNoExternCmd) {
		//OR}hgȂꍇ̓\Pbg̏s
		//iAdministrators[U[݂̂gpłj
		sock = ICMP_Init(-1, -1, &dwErr);
	}
	if (sock != INVALID_SOCKET) {
		//Õ\PbgICMP𑗂iAdministrators[U[݂̂gpłj
		ret = ICMP_Check(sock, (LPCTSTR)sHost, m_TimeOut);
	} else {
		//ping R}hĂяoiAdministratorsłȂ[U[gpꍇj
		ret = PingCheck((char *)((LPCTSTR)sHost), m_TimeOut);
	}
	if (m_bNoExternCmd) {
		//OR}hgȂꍇ̓\PbgN[Y
		ICMP_End(sock);
	}
	if (ret != 0) {
		return FALSE;
	}
	return TRUE;
}

//wzXg̋N󋵂`FbN
// sockINVALID_SOCKET̏ꍇpingR}hgp
BOOL	CWinWolDlg::CheckAliveHost(SOCKET sock, int idx)
{
	CString		sIpAddr, sNetMask, sHost;
	DWORD		dwIpAddr, dwNetMask, dwBroadCast;
	CString		sAlive;
	BOOL		bAlive = FALSE;
	int			res;

	TRACE("CWinWolDlg::CheckAliveHost(%d) Start\n", idx);

	sIpAddr = m_HostArray[idx].ipaddr;
	sNetMask = m_HostArray[idx].netmask;
	sHost = m_HostArray[idx].hostname;

	if (sIpAddr.IsEmpty()) {
		return FALSE;
	}
	// IPAhXoCiɕϊ
	dwIpAddr = StrToDwIpAddr((LPCTSTR)sIpAddr);

	if (sNetMask.IsEmpty()) {
		//ftHg̃lbg}XN擾
		dwNetMask = GetDefaultNetMask(dwIpAddr);
	} else {
		// lbg}XNoCiɕϊ
		dwNetMask = StrToDwIpAddr((LPCTSTR)sNetMask);
	}
	// IPAhXƃlbg}XNu[hLXgEAhX𐶐
	dwBroadCast = dwIpAddr | ~dwNetMask;

	if (dwIpAddr == dwBroadCast) {
		//u[hLXg͂Ȃ
		return bAlive;
	}
	if (sock != INVALID_SOCKET) {
		//Õ\PbgICMP𑗂iAdministratorsłȂ[U[݂̂gpłj
		res = ICMP_Check(sock, (char *)((LPCTSTR)sIpAddr), m_TimeOut);
	} else {
		//ping R}hĂяoiAdministratorsłȂ[U[gpꍇj
		res = PingCheck((char *)((LPCTSTR)sIpAddr), m_TimeOut);
	}
	if (res == 0) {
		m_HostArray[idx].active = 1;
		bAlive = TRUE;
		TRACE("ICMP_Check(%s) : host=%s : OK\n", sIpAddr, sHost);
	} else {
		m_HostArray[idx].active = 0;
		bAlive = FALSE;
		TRACE("ICMP_Check(%s) : host=%s : NG\n", sIpAddr, sHost);
	}
	TRACE("CWinWolDlg::CheckAliveHost(%d) End\n", idx);

	return bAlive;
}

void CWinWolDlg::ShutDownWindowsHost(int idx)
{
	CWaitCursor			csr;
	int					cnt;
	CString				sErr;
	TCHAR				szCmd[2048];

	cnt = m_ListHosts.GetItemCount();
	if (idx >= cnt) {
		return;
	}
	m_SelHostName = m_ListHosts.GetItemText(idx, LIST_ITEM_HOST_NAME);
	m_SelComment = m_ListHosts.GetItemText(idx, LIST_ITEM_COMMENT);
	m_SelIpAddr = m_ListHosts.GetItemText(idx, LIST_ITEM_IP_ADDR);
	m_SelNetMask = m_ListHosts.GetItemText(idx, LIST_ITEM_NET_MASK);
	m_SelMacAddr = m_ListHosts.GetItemText(idx, LIST_ITEM_MAC_ADDR);
	if (m_SelIpAddr.IsEmpty()) {
		sErr.LoadString(IDS_STRING_HOST_ADDRESS_EMPTY);
		MessageBox(sErr);
		return;
	}

	sprintf_s(szCmd, sizeof(szCmd), "shutdown /s /m \\\\%s /t 0", m_SelIpAddr);

	// OR}hs
	if (RunCommand(szCmd, FALSE, TRUE) != 0) {
		sErr.LoadString(IDS_REMOTE_SHUTDOWN_FAILED);
		MessageBox(sErr);
	}
}

void	CWinWolDlg::SetAliveMark(int idx)
{
	LVITEM		lvitem;
	tHostInfo	info = m_HostArray.GetAt(idx);

	if (m_nActiveMarkType == ACTIVE_MARK_TYPE_ICON) {
		lvitem.iItem = idx;
		m_ListHosts.GetItem(&lvitem);
		lvitem.mask = LVIF_STATE;
		lvitem.iSubItem = 0;
		if (info.active) {
			lvitem.stateMask = LVIS_STATEIMAGEMASK;
			lvitem.state = INDEXTOSTATEIMAGEMASK(ACTIVE_IMAGE_IDX);
		} else {
			lvitem.stateMask = LVIS_STATEIMAGEMASK;
			lvitem.state = INDEXTOSTATEIMAGEMASK(INACTIVE_IMAGE_IDX);
		}
		m_ListHosts.SetItem(&lvitem);
	} else {
		CString	sAlive;

		if (info.active) {
			sAlive = m_sAvtiveMark;
		} else {
			sAlive = "";
		}
		m_ListHosts.SetItemText(idx, LIST_ITEM_ACTIVE, (LPCTSTR)sAlive);
	}
}

void	CWinWolDlg::RefreshAliveMark(int idx)
{
	int	cnt;
	int	i;

	EnterCriticalSection(&m_csListItem);

	cnt = m_HostArray.GetCount();
	if (idx >= cnt) {
		return;
	}
	if (idx < 0) {
		//ׂčXV
		for (i = 0; i < cnt; i++) {
			SetAliveMark(i);
		}
	} else {
		//w̃zXĝݍXV
		SetAliveMark(idx);
	}
	LeaveCriticalSection(&m_csListItem);
}

//Xg̃zXgN󋵂XV
void CWinWolDlg::RefreshAliveHost(int idx) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int				i, cnt;
	SOCKET			sock = INVALID_SOCKET;
	CString			strErr;
	DWORD			dwErr;

	EnterCriticalSection(&m_csRefresh);

	TRACE("CWinWolDlg::RefreshAliveHost(%d) Start\n", idx);

	cnt = m_HostArray.GetCount();
	if (idx >= cnt) {
		LeaveCriticalSection(&m_csRefresh);
		return;
	}
	if (m_bNoExternCmd) {
		//OR}hgȂꍇ̓\Pbg̏s
		//iAdministratorsłȂ[U[݂̂gpłj
		if ((sock = ICMP_Init(-1, -1, &dwErr)) == INVALID_SOCKET) {
			strErr.Format("ICMP_Init(): error:(%u)%s", dwErr, GetErrorString(dwErr));
			MessageBox(strErr);
			LeaveCriticalSection(&m_csRefresh);
			return;
		}
	}
	if (idx < 0) {
		//ׂčXV
		for (i = 0; i < cnt && m_bWorkActive == TRUE; i++) {
			// ICMP̉`FbN
			// sockINVALID_SOCKET̏ꍇpingR}hgp
			CheckAliveHost(sock, i);
		}
	} else {
		//w̃zXĝݍXV
		CheckAliveHost(sock, idx);
	}
	if (m_bNoExternCmd) {
		//OR}hgȂꍇ̓\PbgN[Y
		ICMP_End(sock);
	}
	LeaveCriticalSection(&m_csRefresh);

	TRACE("CWinWolDlg::RefreshAliveHost(%d) End\n", idx);
}

//zXgҏW
BOOL	CWinWolDlg::EditHost(int idx)
{
	int	count = m_ListHosts.GetItemCount();
	if (idx < 0 || count <= idx) {
		return FALSE;
	}
	m_SelHostName = m_ListHosts.GetItemText(idx, LIST_ITEM_HOST_NAME);
	m_SelComment = m_ListHosts.GetItemText(idx, LIST_ITEM_COMMENT);
	m_SelIpAddr = m_ListHosts.GetItemText(idx, LIST_ITEM_IP_ADDR);
	m_SelNetMask = m_ListHosts.GetItemText(idx, LIST_ITEM_NET_MASK);
	m_SelMacAddr = m_ListHosts.GetItemText(idx, LIST_ITEM_MAC_ADDR);

	CHostEditDlg	dlg;

	dlg.SetHostName((LPCTSTR)m_SelHostName);
	dlg.SetComment((LPCTSTR)m_SelComment);
	dlg.SetIpAddr((LPCTSTR)m_SelIpAddr);
	dlg.SetNetMask((LPCTSTR)m_SelNetMask);
	dlg.SetMacAddr((LPCTSTR)m_SelMacAddr);
	dlg.SetTimeOut(m_TimeOut);

	if (dlg.DoModal() == IDOK) {
		tHostInfo	info;

		m_SelHostName = dlg.GetHostName();
		m_SelComment = dlg.GetComment();
		m_SelIpAddr = dlg.GetIpAddr();
		m_SelNetMask = dlg.GetNetMask();
		m_SelMacAddr = dlg.GetMacAddr();

		EnterCriticalSection(&m_csListItem);

		info = m_HostArray.GetAt(idx);

		strcpy_s(info.hostname, sizeof(info.hostname), (LPCTSTR)m_SelHostName);
		strcpy_s(info.comment, sizeof(info.comment), (LPCTSTR)m_SelComment);
		strcpy_s(info.ipaddr, sizeof(info.ipaddr), (LPCTSTR)m_SelIpAddr);
		strcpy_s(info.netmask, sizeof(info.netmask), (LPCTSTR)m_SelNetMask);
		strcpy_s(info.macaddr, sizeof(info.macaddr), (LPCTSTR)m_SelMacAddr);

		m_HostArray.SetAt(idx, info);

		m_ListHosts.SetItemText(idx, LIST_ITEM_ACTIVE, (LPCTSTR)"");
		m_ListHosts.SetItemText(idx, LIST_ITEM_HOST_NAME, (LPCTSTR)m_SelHostName);
		m_ListHosts.SetItemText(idx, LIST_ITEM_COMMENT, (LPCTSTR)m_SelComment);
		m_ListHosts.SetItemText(idx, LIST_ITEM_IP_ADDR, (LPCTSTR)m_SelIpAddr);
		m_ListHosts.SetItemText(idx, LIST_ITEM_NET_MASK, (LPCTSTR)m_SelNetMask);
		m_ListHosts.SetItemText(idx, LIST_ITEM_MAC_ADDR, (LPCTSTR)m_SelMacAddr);

		LeaveCriticalSection(&m_csListItem);

		// 쒆̃zXgɃ}[N\
		RefreshAliveHost(idx);
		RefreshAliveMark(idx);
	}
	return TRUE;
}

void	CWinWolDlg::ListItemUp(int idx)
{
	if (m_bCollectActive) {
		return;
	}
	int		count = m_HostArray.GetCount();

	if (0 < idx  && idx < count) {
		EnterCriticalSection(&m_csListItem);

		tHostInfo	Info = m_HostArray.GetAt(idx);

		m_HostArray.RemoveAt(idx);
		idx--;
		m_HostArray.InsertAt(idx, Info);

		LeaveCriticalSection(&m_csListItem);

		RefreshHostList();

		m_ListHosts.SetItemState(idx, LVIS_SELECTED, LVIS_SELECTED);

		RefreshStart();
	}
}

void	CWinWolDlg::ListItemDown(int idx)
{
	if (m_bCollectActive) {
		return;
	}
	int count = m_HostArray.GetCount();

	if (0 <= idx && idx < count - 1) {
		EnterCriticalSection(&m_csListItem);

		tHostInfo	Info = m_HostArray.GetAt(idx);

		m_HostArray.RemoveAt(idx);

		count--;
		idx++;

		if (idx > count - 1) {
			m_HostArray.Add(Info);
		} else {
			m_HostArray.InsertAt(idx, Info);
		}
		LeaveCriticalSection(&m_csListItem);

		RefreshHostList();

		m_ListHosts.SetItemState(idx, LVIS_SELECTED, LVIS_SELECTED);

		RefreshStart();
	}
}

void	CWinWolDlg::LoadIniFile(void)
{
	UINT		uiVal;
	CString		sDflt;
	char		buf[1024];

	// |[gԍ
	sDflt.Format("%u", m_PortNo);
	if (GetPrivateProfileString("SETTING", "PORT_NO", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_PortNo = atoi(buf);
	}
	//ICMP^CAEg
	sDflt.Format("%u", m_TimeOut);
	if (GetPrivateProfileString("SETTING", "ICMP_TIME_OUT", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal > 0) {
			m_TimeOut = uiVal;
		}
	}
	//zXgWICMP^CAEg
	sDflt.Format("%u", m_CollectHostTimeOut);
	if (GetPrivateProfileString("SETTING", "COLLECT_HOST_ICMP_TIME_OUT", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal > 0) {
			m_CollectHostTimeOut = uiVal;
		}
	}
	//zXgW̊JnAhX
	if (GetPrivateProfileString("SETTING", "COLLECT_HOST_ADDR_START", m_sCollectHostStart,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_sCollectHostStart = buf;
	}
	//zXgW̏IAhX
	if (GetPrivateProfileString("SETTING", "COLLECT_HOST_ADDR_END", m_sCollectHostEnd,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_sCollectHostEnd = buf;
	}
	//zXgW̃lbg}XN
	if (GetPrivateProfileString("SETTING", "COLLECT_HOST_NET_MASK", m_sCollectHostEnd,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_sCollectHostNetMask = buf;
	}
	//őo^zXg
	sDflt.Format("%u", m_MaxHostNum);
	if (GetPrivateProfileString("SETTING", "MAX_HOST_NUM", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal > 0) {
			m_MaxHostNum = uiVal;
		}
	}

	//zXgꗗ̋Ƃ̍ݒt@CɋL^
	sDflt.Format("%u", m_ListRowHeight);
	if (GetPrivateProfileString("SETTING", "LIST_ROW_HEIGHT", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal > 0) {
			m_ListRowHeight = uiVal;
		}
	}

	//\̎XVs
	sDflt.Format("%u", (m_bAutoRefresh ? 1 : 0));
	if (GetPrivateProfileString("SETTING", "AUTO_REFRESH", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal) {
			m_bAutoRefresh = TRUE;
		} else {
			m_bAutoRefresh = FALSE;
		}
	}
	//[gVbg_E@\Lɂ邩
	sDflt.Format("%u", (m_bEnableRemoteShutdown ? 1 : 0));
	if (GetPrivateProfileString("SETTING", "ENABLE_REMOTE_SHUTDOWN", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal) {
			m_bEnableRemoteShutdown = TRUE;
		} else {
			m_bEnableRemoteShutdown = FALSE;
		}
	}
	//\XV̊Ԋu
	sDflt.Format("%u", m_TimerInterval);
	if (GetPrivateProfileString("SETTING", "TIMER_INTERVAL", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal > 0) {
			m_TimerInterval = uiVal;
		}
	}
	//NɃXĝׂẴzXg̋N`FbNs
	sDflt.Format("%u", (m_bInitRefresh ? 1 : 0));
	if (GetPrivateProfileString("SETTING", "INIT_REFRESH", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal == 0) {
			m_bInitRefresh = false;
		} else {
			m_bInitRefresh = true;
		}
	}

	//O pingR}hgp邩
	sDflt.Format("%u", (m_bNoExternCmd ? 1 : 0));
	if (GetPrivateProfileString("SETTING", "NO_EXTERNAL_COMMAND", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal == 0) {
			m_bNoExternCmd = false;
		} else {
			m_bNoExternCmd = true;
		}
	}

	//lbg[NEZOg̃`FbN邩ĩZOgɂM邩j
	sDflt.Format("%u", (m_bCheckNetworkSegment ? 1 : 0));
	if (GetPrivateProfileString("SETTING", "CHECK_NETWORK_SEGMENT", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal == 0) {
			m_bCheckNetworkSegment = false;
		} else {
			m_bCheckNetworkSegment = true;
		}
	}

	//ANeBuȃzXg̕\`
	sDflt.Format("%u", m_nActiveMarkType);
	if (GetPrivateProfileString("SETTING", "ACTIVE_MARK_TYPE", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		uiVal = atoi(buf);
		if (uiVal == 0) {
			m_nActiveMarkType = 0;
		} else {
			m_nActiveMarkType = 1;
		}
	}

	//ANeBuEC[W̃}XN̐F
	sDflt.Format("#%02X%02X%02X", GetRValue(m_ActiveImgMaskColor),
						GetGValue(m_ActiveImgMaskColor), GetBValue(m_ActiveImgMaskColor));
	if (GetPrivateProfileString("SETTING", "ACTIVE_IMG_MASK_COLOR", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		int	r, g, b;
		if (sscanf_s(buf, "#%02X%02X%02X", &r, &g, &b) == 3) {
			m_ActiveImgMaskColor = RGB(r, g, b);
		}
	}

	//ANeBuȃzXg̕F
	sDflt.Format("#%02X%02X%02X", GetRValue(m_ActiveFgColor),
							GetGValue(m_ActiveFgColor), GetBValue(m_ActiveFgColor));
	if (GetPrivateProfileString("SETTING", "ACTIVE_MARK_TEXT_COLOR", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		int	r, g, b;
		if (sscanf_s(buf, "#%02X%02X%02X", &r, &g, &b) == 3) {
			m_ActiveFgColor = RGB(r, g, b);
		}
	}

	//ANeBuȃzXg̔wiF
	sDflt.Format("#%02X%02X%02X", GetRValue(m_ActiveBgColor),
							GetGValue(m_ActiveBgColor), GetBValue(m_ActiveBgColor));
	if (GetPrivateProfileString("SETTING", "ACTIVE_MARK_BACK_COLOR", sDflt,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		int	r, g, b;
		if (sscanf_s(buf, "#%02X%02X%02X", &r, &g, &b) == 3) {
			m_ActiveBgColor = RGB(r, g, b);
		}
	}

	//ANeBuȃzXg̃}[N
	if (GetPrivateProfileString("SETTING", "ACTIVE_MARK_TEXT", m_sAvtiveMark,
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		if (buf[0]) {
			m_sAvtiveMark = buf;
		}
	}

	//񕝂擾
	memset(m_nColWidth, 0, sizeof(m_nColWidth));

	//N
	if (GetPrivateProfileString("WINDOW", "ITEM_WIDTH_BOOT", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_nColWidth[LIST_ITEM_ACTIVE] = atoi(buf);
	}
	//zXg
	if (GetPrivateProfileString("WINDOW", "ITEM_WIDTH_HOST_NAME", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_nColWidth[LIST_ITEM_HOST_NAME] = atoi(buf);
	}
	//Rg
	if (GetPrivateProfileString("WINDOW", "ITEM_WIDTH_COMMENT", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_nColWidth[LIST_ITEM_COMMENT] = atoi(buf);
	}
	//IPAhX
	if (GetPrivateProfileString("WINDOW", "ITEM_WIDTH_IP_ADDR", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_nColWidth[LIST_ITEM_IP_ADDR] = atoi(buf);
	}
	//lbg}XN
	if (GetPrivateProfileString("WINDOW", "ITEM_WIDTH_NET_MASK", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_nColWidth[LIST_ITEM_NET_MASK] = atoi(buf);
	}
	//MACAhX
	if (GetPrivateProfileString("WINDOW", "ITEM_WIDTH_MAC_ADDR", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		m_nColWidth[LIST_ITEM_MAC_ADDR] = atoi(buf);
	}
}

void	CWinWolDlg::SaveIniFile(void)
{
	CString str;
	int		idx;
	int		cnt;
	int		def;
	CRect	rect;
	int		width;
	int		flg;
	char	buf[256];

	// |[gԍݒt@CɋL^
	str.Format("%u", m_PortNo);
	WritePrivateProfileString("SETTING", "PORT_NO", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//ICMP^CAEgݒt@CɋL^
	str.Format("%u", m_TimeOut);
	WritePrivateProfileString("SETTING", "ICMP_TIME_OUT", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//zXgWICMP^CAEg
	str.Format("%u", m_CollectHostTimeOut);
	WritePrivateProfileString("SETTING", "COLLECT_HOST_ICMP_TIME_OUT", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//zXgW̊JnAhX
	WritePrivateProfileString("SETTING", "COLLECT_HOST_ADDR_START", 
						(LPCTSTR)m_sCollectHostStart, (LPCTSTR)m_IniFileName);

	//zXgW̏IAhX
	WritePrivateProfileString("SETTING", "COLLECT_HOST_ADDR_END", 
						(LPCTSTR)m_sCollectHostEnd, (LPCTSTR)m_IniFileName);

	//zXgW̃lbg}XN
	WritePrivateProfileString("SETTING", "COLLECT_HOST_NET_MASK", 
						(LPCTSTR)m_sCollectHostNetMask, (LPCTSTR)m_IniFileName);

	//őo^zXgݒt@CɋL^
	str.Format("%u", m_MaxHostNum);
	WritePrivateProfileString("SETTING", "MAX_HOST_NUM", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);
	
	//zXgꗗ̋Ƃ̍ݒt@CɋL^
	str.Format("%u", m_ListRowHeight);
	WritePrivateProfileString("SETTING", "LIST_ROW_HEIGHT", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//\̎XVs
	str.Format("%u", (m_bAutoRefresh ? 1 : 0));
	WritePrivateProfileString("SETTING", "AUTO_REFRESH", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//[gVbg_E@\Lɂ邩
	str.Format("%u", (m_bEnableRemoteShutdown ? 1 : 0));
	WritePrivateProfileString("SETTING", "ENABLE_REMOTE_SHUTDOWN", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//\XV̊Ԋu
	str.Format("%u", m_TimerInterval);
	WritePrivateProfileString("SETTING", "TIMER_INTERVAL", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//ÑXgXV
	str.Format("%u", (m_bInitRefresh ? 1 : 0));
	WritePrivateProfileString("SETTING", "INIT_REFRESH", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//OR}h(ping)̎gp
	str.Format("%u", (m_bNoExternCmd ? 1 : 0));
	WritePrivateProfileString("SETTING", "NO_EXTERNAL_COMMAND", 
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//lbg[NEZOg̃`FbN邩ĩZOgɂM邩j
	str.Format("%u", (m_bCheckNetworkSegment ? 1 : 0));
	WritePrivateProfileString("SETTING", "CHECK_NETWORK_SEGMENT",
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//ANeBuȃzXg̕\`
	str.Format("%u", m_nActiveMarkType);
	WritePrivateProfileString("SETTING", "ACTIVE_MARK_TYPE",
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//ANeBuEC[W̃}XN̐F
	str.Format("#%02X%02X%02X", GetRValue(m_ActiveImgMaskColor),
						GetGValue(m_ActiveImgMaskColor), GetBValue(m_ActiveImgMaskColor));
	WritePrivateProfileString("SETTING", "ACTIVE_IMG_MASK_COLOR",
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//ANeBuȃzXg̕F
	str.Format("#%02X%02X%02X", GetRValue(m_ActiveFgColor), 
							GetGValue(m_ActiveFgColor), GetBValue(m_ActiveFgColor));
	WritePrivateProfileString("SETTING", "ACTIVE_MARK_TEXT_COLOR",
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	//ANeBuȃzXg̔wiF
	str.Format("#%02X%02X%02X", GetRValue(m_ActiveBgColor), 
							GetGValue(m_ActiveBgColor), GetBValue(m_ActiveBgColor));
	WritePrivateProfileString("SETTING", "ACTIVE_MARK_BACK_COLOR",
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);
	
	//ANeBuȃzXg̃}[N
	str.Format("\"%s\"", m_sAvtiveMark);
	WritePrivateProfileString("SETTING", "ACTIVE_MARK_TEXT",
						(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	// zXgꗗ̓o^
	cnt = m_ListHosts.GetItemCount();

	// IĂzXg̃CfbNX𓾂
	def = -1;
	for (idx = 0; idx < cnt; idx++) {
		if (m_ListHosts.GetItemState(idx, LVIS_SELECTED)) {
			def = idx;
			break;
		}
	}
	// ftHg̃zXgԍݒt@CɋL^
	str.Format("%d", def);
	WritePrivateProfileString("SETTING", "DEFAULT_HOST",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	GetWindowRect(&rect);
	str.Format("%d", rect.left);
	WritePrivateProfileString("WINDOW", "WINDOW_X",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);
	str.Format("%d", rect.top);
	WritePrivateProfileString("WINDOW", "WINDOW_Y",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);
	str.Format("%d", rect.Width());
	WritePrivateProfileString("WINDOW", "WINDOW_WIDTH",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);
	str.Format("%d", rect.Height());
	WritePrivateProfileString("WINDOW", "WINDOW_HEIGHT",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	width = m_ListHosts.GetColumnWidth(LIST_ITEM_ACTIVE);
	str.Format("%d", width);	//擪̓GbW̕ȂĂ
	WritePrivateProfileString("WINDOW", "ITEM_WIDTH_BOOT",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	width = m_ListHosts.GetColumnWidth(LIST_ITEM_HOST_NAME);
	str.Format("%d", width);
	WritePrivateProfileString("WINDOW", "ITEM_WIDTH_HOST_NAME",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	width = m_ListHosts.GetColumnWidth(LIST_ITEM_COMMENT);
	str.Format("%d", width);
	WritePrivateProfileString("WINDOW", "ITEM_WIDTH_COMMENT",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	width = m_ListHosts.GetColumnWidth(LIST_ITEM_IP_ADDR);
	str.Format("%d", width);
	WritePrivateProfileString("WINDOW", "ITEM_WIDTH_IP_ADDR",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	width = m_ListHosts.GetColumnWidth(LIST_ITEM_NET_MASK);
	str.Format("%d", width);
	WritePrivateProfileString("WINDOW", "ITEM_WIDTH_NET_MASK",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	width = m_ListHosts.GetColumnWidth(LIST_ITEM_MAC_ADDR);
	str.Format("%d", width);
	WritePrivateProfileString("WINDOW", "ITEM_WIDTH_MAC_ADDR",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	cnt = m_HostArray.GetCount();

	// zXgꗗ̓eݒt@CɋL^
	for (idx = 0; idx < cnt; idx++) {
		m_SelHostName = m_HostArray[idx].hostname;
		m_SelComment = m_HostArray[idx].comment;
		m_SelIpAddr = m_HostArray[idx].ipaddr;
		m_SelNetMask = m_HostArray[idx].netmask;
		m_SelMacAddr = m_HostArray[idx].macaddr;

		str.Format("HOST_%d", idx);

		WritePrivateProfileString(str, "HOST_NAME", 
						(LPCTSTR)m_SelHostName, (LPCTSTR)m_IniFileName);

		WritePrivateProfileString(str, "COMMENT", 
						(LPCTSTR)m_SelComment, (LPCTSTR)m_IniFileName);

		WritePrivateProfileString(str, "IP_ADDR", 
						(LPCTSTR)m_SelIpAddr, (LPCTSTR)m_IniFileName);

		WritePrivateProfileString(str, "NET_MASK", 
						(LPCTSTR)m_SelNetMask, (LPCTSTR)m_IniFileName);

		WritePrivateProfileString(str, "MAC_ADDR", 
						(LPCTSTR)m_SelMacAddr, (LPCTSTR)m_IniFileName);
	}

	// 폜ꂽzXgݒt@C폜
	for ( ; idx < (int)m_MaxHostNum; idx++) {
		flg = 0;

		str.Format("HOST_%d", idx);

		GetPrivateProfileString(str, "HOST_NAME", "",
									buf, sizeof(buf), (LPCTSTR)m_IniFileName);
		if (!buf[0]) {
			flg = 1;
		}
		GetPrivateProfileString(str, "COMMENT", "",
									buf, sizeof(buf), (LPCTSTR)m_IniFileName);
		if (!buf[0]) {
			flg = 1;
		}
		GetPrivateProfileString(str, "IP_ADDR", "",
									buf, sizeof(buf), (LPCTSTR)m_IniFileName);
		if (!buf[0]) {
			flg = 1;
		}
		GetPrivateProfileString(str, "NET_MASK", "",
									buf, sizeof(buf), (LPCTSTR)m_IniFileName);
		if (!buf[0]) {
			flg = 1;
		}
		GetPrivateProfileString(str, "MAC_ADR", "",
									buf, sizeof(buf), (LPCTSTR)m_IniFileName);
		if (!buf[0]) {
			flg = 1;
		}
		if (flg) {
			WritePrivateProfileString(str, NULL, NULL, (LPCTSTR)m_IniFileName);
		}
	}
}

void	CWinWolDlg::InitDialog(void)
{
	CString		str, tmp;
	char		buf[128];
	int			col_w;
	int			lst_w = 0;
	int			lst_h;
	double		col_margin = 1.15;
	CString		ActiveFname, InactiveFname;
	CString		dbg;

	m_ImgList.Create(1, m_ListRowHeight, ILC_COLOR, 0, 0);

	m_ListHosts.SetImageList(&m_ImgList, LVSIL_SMALL);

	ActiveFname.Format("%s%s", m_sModuleDir, BMP_FILE_ACTIVE);;
	InactiveFname.Format("%s%s", m_sModuleDir, BMP_FILE_INACTIVE);

	if (GetFileAttributes(ActiveFname) != (DWORD)-1 &&
						GetFileAttributes(InactiveFname) != (DWORD)-1) {
		CImage	img;

		//ԃACRTCYϊp̃rbg}bv쐬
		if (img.Create(16, 16, 24)) {
			HDC		hdc;
			CBitmap	*pBmp;
			CImage	src_img;

			m_ImageListStatus.Create(LIST_ICON_WIDTH, LIST_ICON_HEIGHT, ILC_COLOR24 | ILC_MASK, 2, 0);

			hdc = img.GetDC();
			SetStretchBltMode(hdc, COLORONCOLOR);

			//ғԃACRp̃rbg}bvǍ
			if (src_img.Load(InactiveFname) != S_OK) {
				src_img.LoadFromResource(GetModuleHandle(NULL), IDB_BITMAP_INACTIVE);
			}
			src_img.Draw(hdc, 0, 0, 16, 16, 0, 0, src_img.GetWidth(), src_img.GetHeight());
			src_img.Destroy();

			img.ReleaseDC();

			pBmp = CBitmap::FromHandle((HBITMAP)img);

			m_ImageListStatus.Add(pBmp, m_ActiveImgMaskColor);

			hdc = img.GetDC();
			SetStretchBltMode(hdc, COLORONCOLOR);

			//ғԃACRp̃rbg}bvǍ
			if (src_img.Load(ActiveFname) != S_OK) {
				src_img.LoadFromResource(GetModuleHandle(NULL), IDB_BITMAP_ACTIVE);
			}
			src_img.Draw(hdc, 0, 0, 16, 16, 0, 0, src_img.GetWidth(), src_img.GetHeight());
			src_img.Destroy();

			img.ReleaseDC();

			pBmp = CBitmap::FromHandle((HBITMAP)img);

			m_ImageListStatus.Add(pBmp, m_ActiveImgMaskColor);

			img.Destroy();
		} else {
			m_ImageListStatus.Create(IDB_IMG_LIST_STATUS, LIST_ICON_WIDTH, 1, RGB(0, 0, 255));
		}
	} else {
		m_ImageListStatus.Create(IDB_IMG_LIST_STATUS, LIST_ICON_WIDTH, 1, RGB(0, 0, 255));
	}
	if (m_nActiveMarkType == ACTIVE_MARK_TYPE_ICON) {
		m_ListHosts.SetImageList(&m_ImageListStatus, LVSIL_STATE);
	}

	//N
	str.LoadString(IDS_STRING_BOOT_MARK);
	if (m_nColWidth[LIST_ITEM_ACTIVE] > 0) {
		col_w = m_nColWidth[LIST_ITEM_ACTIVE];
	} else {
		tmp.Format(" %s ", str);
		col_w = m_ListHosts.GetStringWidth(tmp);
		col_w = (int)((double)col_w * col_margin);
		m_nColWidth[LIST_ITEM_ACTIVE] = col_w;
		dbg.Format("COL_W=%d", col_w);
	}
	m_ListHosts.InsertColumn(LIST_ITEM_ACTIVE, str, LVCFMT_CENTER, col_w);
	lst_w += col_w;

	//zXg
	str.LoadString(IDS_STRING_HOST_NAME);
	if (m_nColWidth[LIST_ITEM_HOST_NAME] > 0) {
		col_w = m_nColWidth[LIST_ITEM_HOST_NAME];
	} else {
		col_w = m_ListHosts.GetStringWidth("AAAAAAAAAABBBBBBBBBBCCCCCCCC");
		col_w = (int)((double)col_w * col_margin);
		m_nColWidth[LIST_ITEM_HOST_NAME] = col_w;
		dbg.AppendFormat(":%d", col_w);
	}
	m_ListHosts.InsertColumn(LIST_ITEM_HOST_NAME, str, LVCFMT_LEFT, col_w);
	lst_w += col_w;

	//Rg
	str.LoadString(IDS_STRING_COMMENT);
	if (m_nColWidth[LIST_ITEM_COMMENT] > 0) {
		col_w = m_nColWidth[LIST_ITEM_COMMENT];
	} else {
		col_w = m_ListHosts.GetStringWidth("AAAAAAAAAABBBBBBBBBBCCCCCCCC");
		col_w = (int)((double)col_w * col_margin);
		m_nColWidth[LIST_ITEM_COMMENT] = col_w;
		dbg.AppendFormat(":%d", col_w);
	}
	m_ListHosts.InsertColumn(LIST_ITEM_COMMENT, str, LVCFMT_LEFT, col_w);
	lst_w += col_w;

	//IPAhX
	str.LoadString(IDS_STRING_IP_ADDRESS);
	if (m_nColWidth[LIST_ITEM_IP_ADDR] > 0) {
		col_w = m_nColWidth[LIST_ITEM_IP_ADDR];
	} else {
		col_w = m_ListHosts.GetStringWidth("255.255.255.255 ");
		col_w = (int)((double)col_w * col_margin);
		m_nColWidth[LIST_ITEM_IP_ADDR] = col_w;
		dbg.AppendFormat(":%d", col_w);
	}
	m_ListHosts.InsertColumn(LIST_ITEM_IP_ADDR, str, LVCFMT_LEFT, col_w);
	lst_w += col_w;

	//lbg}XN
	str.LoadString(IDS_STRING_NETMASK);
	if (m_nColWidth[LIST_ITEM_IP_ADDR] > 0) {
		col_w = m_nColWidth[LIST_ITEM_IP_ADDR];
	} else {
		col_w = m_ListHosts.GetStringWidth("255.255.255.255 ");
		col_w = (int)((double)col_w * col_margin);
		m_nColWidth[LIST_ITEM_IP_ADDR] = col_w;
		dbg.AppendFormat(":%d", col_w);
	}
	m_ListHosts.InsertColumn(LIST_ITEM_NET_MASK, str, LVCFMT_LEFT, col_w);
	lst_w += col_w;

	//MACAhX
	str.LoadString(IDS_STRING_MAC_ADDRESS);
	if (m_nColWidth[LIST_ITEM_MAC_ADDR] > 0) {
		col_w = m_nColWidth[LIST_ITEM_MAC_ADDR];
	} else {
		col_w = m_ListHosts.GetStringWidth("DD:DD:DD:DD:DD:DD ");
		col_w = (int)((double)col_w * col_margin);
		m_nColWidth[LIST_ITEM_MAC_ADDR] = col_w;
		dbg.AppendFormat(":%d", col_w);
	}
	dbg.AppendFormat("\n", col_w);
	TRACE((LPCTSTR)dbg);

	m_ListHosts.InsertColumn(LIST_ITEM_MAC_ADDR, str, LVCFMT_LEFT, col_w);
	lst_w += col_w;

	DWORD	dwStyle = ListView_GetExtendedListViewStyle(m_ListHosts.m_hWnd);

	dwStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_EX_INFOTIP;

	ListView_SetExtendedListViewStyle(m_ListHosts.m_hWnd, dwStyle);

	CRect	dlg_rect;
	CRect	lst_rect;
	CRect	rect;
	int		edge = GetSystemMetrics(SM_CXEDGE) * 4;
	int		scrl_w = GetSystemMetrics(SM_CXHSCROLL) + edge;
	CSize	tb_sz, st_sz;
	CRect	st_rect;

	//Xe[^Xo[쐬
	m_wndStatusBar.Create(this);

	m_wndStatusBar.SetIndicators(idArray, _countof(idArray));

	st_sz = m_wndStatusBar.CalcFixedLayout(FALSE, TRUE);

	//  c[o[̍擾
    tb_sz = m_wndToolBar.CalcFixedLayout(FALSE, TRUE);

	GetWindowRect(&dlg_rect);
	GetClientRect(&rect);

	m_ListHosts.GetWindowRect(&lst_rect);
	ScreenToClient(&lst_rect);

	lst_w = lst_w + edge + scrl_w;

	int	frm_w = dlg_rect.Width() - rect.Width();
	int	frm_h = dlg_rect.Height() - rect.Height();
	int	x = dlg_rect.left;
	int	y = dlg_rect.top;
	int	dlg_h = dlg_rect.Height();
	int	dlg_w = lst_w + (lst_rect.left * 2) + frm_w;

	if (GetPrivateProfileString("WINDOW", "WINDOW_X", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		x = atoi(buf);
	}
	if (GetPrivateProfileString("WINDOW", "WINDOW_Y", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		y = atoi(buf);
	}
	if (GetPrivateProfileString("WINDOW", "WINDOW_WIDTH", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		dlg_w = atoi(buf);
		lst_w = dlg_w - (frm_w + (lst_rect.left * 2));
	}
	if (GetPrivateProfileString("WINDOW", "WINDOW_HEIGHT", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		dlg_h = atoi(buf);
	}
	lst_h = (dlg_h - frm_h) - (lst_rect.top + st_sz.cy + edge);

	m_ListHosts.MoveWindow(lst_rect.left, lst_rect.top, lst_w, lst_h);

	SetWindowPos(NULL, x, y, dlg_w, dlg_h, SWP_NOZORDER);

	GetClientRect(&rect);	//ēxNCAg̈̃TCY擾

    //  쐬͑傫0Ȃ̂Őݒ肷
    m_wndToolBar.MoveWindow( 0, 0, rect.Width(), tb_sz.cy );

   // Xe[^Xo[̍ێđ傫
    // _CAÕNCAgEBhE
    // 傫ɂ킹
    int nwork = st_sz.cy + edge;
    st_rect.top = rect.bottom - nwork;
    st_rect.bottom = st_rect.top + nwork;
    st_rect.left = rect.left;
    st_rect.right = rect.right;
    m_wndStatusBar.MoveWindow(&st_rect);
}

//zXgꗗɃzXgZbg
void	CWinWolDlg::RefreshHostList(void)
{
	int			count;
	int			i;
	LV_ITEM		lvitem;
	tHostInfo	info;
	char		szActive[128];

	EnterCriticalSection(&m_csListItem);

	strcpy_s(szActive, sizeof(szActive), m_sAvtiveMark);

	m_ListHosts.SetRedraw(FALSE);

	m_ListHosts.DeleteAllItems();

	count = m_HostArray.GetCount();

	for (i = 0; i < count; i++) {
		info = m_HostArray.GetAt(i);
		memset(&lvitem, 0, sizeof(lvitem));

		if (m_nActiveMarkType == ACTIVE_MARK_TYPE_ICON) {
			lvitem.mask = LVIF_STATE | LVIF_INDENT;
			lvitem.iItem = i;
			lvitem.iSubItem = LIST_ITEM_ACTIVE;
			lvitem.pszText = "";
			lvitem.iIndent = (m_nColWidth[LIST_ITEM_ACTIVE] - LIST_ICON_WIDTH) / 2;
			lvitem.stateMask = LVIS_STATEIMAGEMASK;
			if (info.active) {
				lvitem.state = INDEXTOSTATEIMAGEMASK(INACTIVE_IMAGE_IDX);
			} else {
				lvitem.state = INDEXTOSTATEIMAGEMASK(INACTIVE_IMAGE_IDX);
			}
		} else {
			lvitem.mask = LVIF_TEXT;
			lvitem.iItem = i;
			lvitem.iSubItem = LIST_ITEM_ACTIVE;
			if (info.active) {
				lvitem.pszText = szActive;
			} else {
				lvitem.pszText = "";
			}
		}
		m_ListHosts.InsertItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = LIST_ITEM_HOST_NAME;
		lvitem.pszText = info.hostname;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = LIST_ITEM_COMMENT;
		lvitem.pszText = info.comment;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = LIST_ITEM_IP_ADDR;
		lvitem.pszText = info.ipaddr;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = LIST_ITEM_NET_MASK;
		lvitem.pszText = info.netmask;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = LIST_ITEM_MAC_ADDR;
		lvitem.pszText = info.macaddr;
		m_ListHosts.SetItem(&lvitem);
	}
	m_ListHosts.SetRedraw(TRUE);

	LeaveCriticalSection(&m_csListItem);
}

void	CWinWolDlg::ChangeActiveIconType(int Type)
{
	if (Type != m_nActiveMarkType) {
		int			i;
		LV_ITEM		lvitem;
		int			count;

		EnterCriticalSection(&m_csListItem);

		count = m_ListHosts.GetItemCount();

		for (i = 0; i < count; i++) {
			memset(&lvitem, 0, sizeof(lvitem));

			lvitem.iItem = i;
			lvitem.iSubItem = LIST_ITEM_ACTIVE;

			m_ListHosts.GetItem(&lvitem);

			if (Type == ACTIVE_MARK_TYPE_ICON) {
				int		indent;
				int		colw = m_ListHosts.GetColumnWidth(LIST_ITEM_ACTIVE);

				indent = (colw - LIST_ICON_WIDTH) / 2;

				lvitem.mask = LVIF_TEXT | LVIF_STATE | LVIF_INDENT;
				lvitem.pszText = "";
				lvitem.iIndent = indent;
				lvitem.stateMask = LVIS_STATEIMAGEMASK;
				lvitem.state = INDEXTOSTATEIMAGEMASK(INACTIVE_IMAGE_IDX);
			} else {
				lvitem.mask = LVIF_TEXT | LVIF_STATE | LVIF_INDENT;
				lvitem.pszText = "";
				lvitem.iIndent = 0;
				lvitem.stateMask = LVIS_STATEIMAGEMASK;
				lvitem.state = 0;
			}
			m_ListHosts.SetItem(&lvitem);
		}
		if (Type == ACTIVE_MARK_TYPE_ICON) {
			m_ListHosts.SetImageList(&m_ImageListStatus, LVSIL_STATE);
		} else {
			m_ListHosts.SetImageList(NULL, LVSIL_STATE);
		}
		m_nActiveMarkType = Type;

		LeaveCriticalSection(&m_csListItem);

		RefreshAliveHost(-1);
	}
}

//Xg̐擪̕ύXꂽ̂ŃACR̃Cfg𒲐
void	CWinWolDlg::RefreshActiveIconIndent(void)
{
	if (m_nActiveMarkType == ACTIVE_MARK_TYPE_ICON) {
		int		idx;
		int		nCount;
		int		indent;

		EnterCriticalSection(&m_csListItem);

		nCount = m_ListHosts.GetItemCount();

		m_nColWidth[LIST_ITEM_ACTIVE] = m_ListHosts.GetColumnWidth(LIST_ITEM_ACTIVE);

		indent = (m_nColWidth[LIST_ITEM_ACTIVE] - LIST_ICON_WIDTH) / 2;

		for (idx = 0; idx < nCount; idx++) {
			LVITEM	lvitem;

			lvitem.iItem = idx;
			m_ListHosts.GetItem(&lvitem);
			lvitem.mask = LVIF_INDENT;
			lvitem.iIndent = indent;
			m_ListHosts.SetItem(&lvitem);
		}
		LeaveCriticalSection(&m_csListItem);
	}
}

void	CWinWolDlg::RefreshStart(BOOL bShowStatus /*= TRUE*/)
{
	if (bShowStatus) {
		CString	str;
		str.LoadString(IDS_STRING_REFRESH_NOW);
		DispStatusMsg(str);
	}
	if (m_bCollectActive) {
		return;
	}
	//ƃXbhɃf[^XVʒm
	SetEvent(m_hWorkEvent);
}

BOOL	CWinWolDlg::SetRegistory(void)
{
    HKEY	hKey;
    DWORD	dwDsp;
	DWORD	dwVal = 1;
    BOOL	bRes = FALSE;

    if (RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\services\\Tcpip\\Parameters",
						NULL, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDsp) == ERROR_SUCCESS) {
        if (RegSetValueEx(hKey, "AllowUserRawAccess", 0, REG_DWORD, (LPBYTE)&dwVal, sizeof(DWORD)) == ERROR_SUCCESS) {
            bRes = TRUE;
        }
        RegCloseKey(hKey);
    }
    return bRes;
}


BOOL CWinWolDlg::SendMagicPacketToListItem(int item, bool bBloadcast /*=TRUE*/)
{
	CString	str;
	char	buf[32];

	m_SelHostName = m_HostArray[item].hostname;
	m_SelIpAddr = m_HostArray[item].ipaddr;
	m_SelNetMask = m_HostArray[item].netmask;
	m_SelMacAddr = m_HostArray[item].macaddr;

	// IPAhXoCiɕϊ
	DWORD dwIpAddr = StrToDwIpAddr((LPCTSTR)m_SelIpAddr);

	if (m_SelIpAddr.IsEmpty()) {
		str.LoadString(IDS_STRING_IP_ADDRESS_NOT_SET);
		MessageBox(str);
		return FALSE;
	}
	if (m_SelMacAddr.IsEmpty()) {
		str.LoadString(IDS_STRING_ILLEGAL_MAC_ADDRESS);
		MessageBox(str);
		return FALSE;
	}
	if (m_SelNetMask.IsEmpty()) {
		DWORD dwMask = GetDefaultNetMask(dwIpAddr);
		m_SelNetMask = DwToStrIpAddr(dwMask, buf, sizeof(buf));
	}
	//lbg[Nǂ`FbNꍇ
	if (m_bCheckNetworkSegment) {
		int					num;
		DWORD				dwMyAddr;
		DWORD				dwNetMask;
		DWORD				dwDstNet;
		DWORD				dwMyNet;
		BOOL				bMyNet = FALSE;

		// lbg}XNoCiɕϊ
		dwNetMask = StrToDwIpAddr((LPCTSTR)m_SelNetMask);

		// IPAhXƃlbg}XNlbg[NAhX𓾂
		dwDstNet = dwIpAddr & dwNetMask;

		//lbg[NA_v^̃AhX̃Xg擾
		if ((num = GetAdapterAddrList(NULL, 0)) > 0) {
			struct sockaddr_in	*pAddr = new struct sockaddr_in[num];
			int					i;

			num = GetAdapterAddrList(pAddr, num);

			for (i = 0; i < num; i++) {
				dwMyAddr = ntohl(pAddr[i].sin_addr.s_addr);

				// ^[Qbg̃lbg}XNgĎg̃lbg[NAhX𐶐
				dwMyNet = dwMyAddr & dwNetMask;

				if (dwDstNet == dwMyNet) {		//@lbg[N
					bMyNet = TRUE;
					break;
				}
			}
		} else {
			// zXgIPAhX擾
			dwMyAddr = GetDwMyIpAddr();

			// ^[Qbg̃lbg}XNgĎg̃lbg[NAhX𐶐
			dwMyNet = dwMyAddr & dwNetMask;

			if (dwDstNet == dwMyNet) {		//@lbg[N
				bMyNet = TRUE;
			}
		}
		if (!bMyNet) {
			CString	tmp;
			tmp.LoadString(IDS_STRING_OTHER_NETWORK);
			str.Format("%s(%s)%s", (LPCTSTR)m_SelHostName, (LPCTSTR)m_SelIpAddr, tmp);

			if (MessageBox((LPCTSTR)str, NULL, MB_YESNO) != IDYES) {
				return FALSE;
			}
		}
	}
	if (SendMagicPacket((LPCTSTR)m_SelIpAddr,
					(LPCTSTR)m_SelNetMask, (LPCTSTR)m_SelMacAddr, bBloadcast) != 0) {
		return FALSE;
	}
	return TRUE;
}

void	CWinWolDlg::WakeupHosts(bool bBloadcast)
{
	int			i, idx, cnt;
	CString		str;
	CWaitCursor	csr;

	if (m_bCollectActive) {
		return;
	}
	UpdateData(TRUE);

	idx = -1;
	cnt = m_ListHosts.GetItemCount();
	for (i = 0; i < cnt; i++) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			if (idx < 0) {
				idx = i;
			}
			if (m_HostArray[i].macaddr[0] && m_HostArray[i].ipaddr[0]) {
				if (!SendMagicPacketToListItem(i, bBloadcast)) {
					break;
				}
			} else {
				if (!m_HostArray[i].macaddr[0]) {
					str.LoadString(IDS_STRING_ILLEGAL_MAC_ADDRESS);
				} else {
					str.LoadString(IDS_STRING_IP_ADDRESS_NOT_SET);
				}
				MessageBox(str);
				return;
			}
		}
	}
	if (idx < 0) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	str.Format("%d", idx);
	WritePrivateProfileString("SETTING", "DEFAULT_HOST",
									(LPCTSTR)str, (LPCTSTR)m_IniFileName);

	RefreshStart();

	ToolBarItemEnable();
}

//XV̗L^
void	CWinWolDlg::EnableAutoRefresh(BOOL bEnable)
{
	if (bEnable) {
		if (!m_RefreshTimerID) {
			m_RefreshTimerID = SetTimer(TIMER_ID_REFRESH, m_TimerInterval * 1000, NULL);
			RefreshStart();
			ToolBarItemEnable();
		}
	} else {
		if (m_RefreshTimerID) {
			KillTimer(m_RefreshTimerID);
			m_RefreshTimerID = 0;
			ToolBarItemEnable();
		}
	}
	m_bAutoRefresh = bEnable;
}

//zXgW
void	CWinWolDlg::CollectHostInfo(DWORD dwStartAddr, DWORD dwEndAddr,
										DWORD dwNetMask, UINT nTimeOut)
{
	char		szIpAddr[32];
	char		szNetMask[32];
	DWORD		dwIpAddr;
	DWORD		dwErr;
	int			i, idx;
	CString		strMsg, strCaption;
	tHostInfo	info;
	int			old_count, count;
	int			res;
	SOCKET		sock = INVALID_SOCKET;
	HWND		hWnd = GetSafeHwnd();

	m_nCollectDetectCount = 0;
	
	DwToStrIpAddr(dwNetMask, szNetMask, sizeof(szNetMask));

	if (m_bNoExternCmd) {
		if ((sock = ICMP_Init(-1, -1, &dwErr)) == INVALID_SOCKET) {
			::PostMessage(hWnd, WM_WOL_WIN_MSG, (WPARAM)WOL_MSG_COLLECT_MSG, (LPARAM)-1);
			return;
		}
	}

	EnterCriticalSection(&m_csListItem);

	count = old_count = m_HostArray.GetCount();

	for (dwIpAddr = dwStartAddr; dwIpAddr <= dwEndAddr && count < (int)m_MaxHostNum; dwIpAddr++) {
		if (!GetCollectActiveFlag()) {
			//f{^ꂽ
			::PostMessage(hWnd, WM_WOL_WIN_MSG, (WPARAM)WOL_MSG_COLLECT_MSG, (LPARAM)-2);
			break;
		}
		m_dwCollectCurrentAddr = dwIpAddr;

		DwToStrIpAddr(dwIpAddr, szIpAddr, sizeof(szIpAddr));

		//`FbÑzXg̃AhX\
		::PostMessage(hWnd, WM_WOL_WIN_MSG, (WPARAM)WOL_MSG_COLLECT_HOST, (LPARAM)dwIpAddr);
	
		if (sock != INVALID_SOCKET) {
			//Õ\PbgICMP𑗂iAdministrators[U[݂̂gpłj
			res = ICMP_Check(sock, szIpAddr, nTimeOut);
		} else {
			//ping R}hĂяoiAdministratorsłȂ[U[gpꍇj
			res = PingCheck(szIpAddr, m_CollectHostTimeOut);
		}
		if (res == 0) {
			m_nCollectDetectCount++;
			::PostMessage(hWnd, WM_WOL_WIN_MSG, (WPARAM)WOL_MSG_DETECT_HOST, (LPARAM)m_nCollectDetectCount);
			idx = -1;
			for (i = 0; i < count; i++) {
				if (strcmp(m_HostArray[i].ipaddr, szIpAddr) == 0) {
					idx = i;
					break;
				}
			}
			if (idx < 0) {
				memset(&info, 0, sizeof(info));

				strcpy_s(info.ipaddr, sizeof(info.ipaddr), szIpAddr);
				strcpy_s(info.netmask, sizeof(info.netmask), szNetMask);

				GetHostNameFromIpAddr(szIpAddr, info.hostname, sizeof(info.hostname));
				IpAddrToMacAddr(szIpAddr, info.macaddr, sizeof(info.macaddr));

				info.active = 1;
				m_HostArray.Add(info);
				count++;
			}
		}
	}
	LeaveCriticalSection(&m_csListItem);

	if (sock != INVALID_SOCKET) {
		ICMP_End(sock);
	}
	//zXgW̏IbZ[W𑗐M
	if (old_count != count) {
		//ύX
		::PostMessage(hWnd, WM_WOL_WIN_MSG, (WPARAM)WOL_MSG_COLLECT_MSG, (LPARAM)1);
	} else {
		//ύXȂ
		::PostMessage(hWnd, WM_WOL_WIN_MSG, (WPARAM)WOL_MSG_COLLECT_MSG, (LPARAM)0);
	}
}

//ғ󋵍XVXbh̏
DWORD	CWinWolDlg::WorkThreadProc(void)
{
	DWORD	dwResult;

	TRACE("CWinWolDlg::WorkThreadProc() Start\n");

	while (m_bWorkActive) {
		dwResult = WaitForSingleObject(m_hWorkEvent, INFINITE);
		if (!m_bWorkActive) {
			break;
		}
		if (dwResult == WAIT_OBJECT_0) {
			if (!m_bCollectActive) {
				RefreshAliveHost(-1);
				PostMessage(WM_WOL_WIN_MSG, (WPARAM)WOL_MSG_REPAINT, (LPARAM)0);
				ResetEvent(m_hWorkEvent);
			}
		} else {
			break;
		}
	}
	TRACE("CWinWolDlg::WorkThreadProc() End\n");

	return 0;
}

//zXgWXbh̏
DWORD	CWinWolDlg::CollectThreadProc(void)
{
	TRACE("CWinWolDlg::CollectThreadProc() Start\n");

	SetCollectActiveFlag(TRUE);

	CollectHostInfo(m_dwCollectStartAddr, m_dwCollectEndAddr, m_dwCollectNetMask, m_CollectHostTimeOut);

	SetCollectActiveFlag(FALSE);

	TRACE("CWinWolDlg::CollectThreadProc() End\n");

	return 0;
}

void CWinWolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_HOST, m_ListHosts);
}

BEGIN_MESSAGE_MAP(CWinWolDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_COMMAND(ID_APP_EXIT, &CWinWolDlg::OnAppExit)
	ON_COMMAND(ID_EDIT_APPEND, &CWinWolDlg::OnEditAppend)
	ON_COMMAND(ID_EDIT_INSERT, &CWinWolDlg::OnEditInsert)
	ON_COMMAND(ID_EDIT_EDIT,   &CWinWolDlg::OnEditEdit)
	ON_COMMAND(ID_EDIT_DELETE, &CWinWolDlg::OnEditDelete)
	ON_COMMAND(ID_VIEW_REFRESH, &CWinWolDlg::OnViewRefresh)
	ON_COMMAND(ID_TOOL_SEND, &CWinWolDlg::OnToolSend)
	ON_COMMAND(ID_TOOL_OPTION, &CWinWolDlg::OnToolOption)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_HOST, &CWinWolDlg::OnLvnItemchangedListHost)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_HOST, &CWinWolDlg::OnNMDblclkListHost)
	ON_NOTIFY( LVN_GETINFOTIP, IDC_LIST_HOST, &CWinWolDlg::OnLvnGetInfoTipListHost)
	ON_WM_SIZE()
	ON_NOTIFY(NM_RCLICK, IDC_LIST_HOST, &CWinWolDlg::OnNMRClickListHost)
	ON_COMMAND(ID_TOOL_GET_IP_ADDR, &CWinWolDlg::OnToolGetIpAddr)
	ON_COMMAND(ID_TOOL_GET_MAC_ADDR, &CWinWolDlg::OnToolGetMacAddr)
	ON_COMMAND(ID_TOOL_GET_HOST, &CWinWolDlg::OnToolGetHost)
	ON_COMMAND(ID_VIEW_CHECK, &CWinWolDlg::OnViewCheck)
	ON_COMMAND(ID_VIEW_PERIOD_START, &CWinWolDlg::OnViewPeriodStart)
	ON_WM_TIMER()
	ON_COMMAND(ID_VIEW_PERIOD_STOP, &CWinWolDlg::OnViewPeriodStop)
	//ON_COMMAND(ID_TOOL_REG_CHANGE, &CWinWolDlg::OnToolRegChange)
	ON_COMMAND(ID_TOOL_SEND_ICMP, &CWinWolDlg::OnToolSendIcmp)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_LIST_HOST, &CWinWolDlg::OnNMCustomdrawListHost)
	ON_COMMAND(ID_TOOL_SHUTDOWN, &CWinWolDlg::OnToolShutdown)
	ON_MESSAGE(WM_WOL_WIN_MSG, &CWinWolDlg::OnWakeOnLanWinMsg)
	ON_MESSAGE(WM_COLLECT_PROC, &CWinWolDlg::OnCollectProcMsg)
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_TOOL_COLLECT_HOST_INFO, &CWinWolDlg::OnToolCollectHostInfo)
	ON_WM_SETCURSOR()
	ON_COMMAND(ID_EDIT_UP, &CWinWolDlg::OnEditUp)
	ON_COMMAND(ID_EDIT_DOWN, &CWinWolDlg::OnEditDown)
	ON_COMMAND(ID_EDIT_COPY, &CWinWolDlg::OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, &CWinWolDlg::OnEditPaste)
	ON_COMMAND(ID_EDIT_CUT, &CWinWolDlg::OnEditCut)
	ON_COMMAND(ID_EDIT_SELECT_ALL, &CWinWolDlg::OnEditSelectAll)
	ON_COMMAND(ID_TOOL_SEND_NON_BLOADCAST, &CWinWolDlg::OnToolSendNonBloadcast)
END_MESSAGE_MAP()

// CWinWolDlg bZ[W nh[

BOOL CWinWolDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	CString		sDflt;
	CString		sec, key;
	TCHAR		buf[1024];
	int			i, count, idx;
	tHostInfo	info;
	WORD		wVer[4];
	CString		sValue;

	GetVersionInfo(buf, sizeof(buf)/sizeof(buf[0]), "ProductName");

	if (GetVersionVal(&wVer[0], &wVer[1], &wVer[2], &wVer[3])) {
		sValue.Format("%s Ver.%u.%02u", buf, wVer[0], wVer[1]);
	} else {
		sValue.Format("%s", buf);
	}
	SetWindowText(sValue);

	InitializeCriticalSection(&m_csCollect);
	InitializeCriticalSection(&m_csRefresh);
	InitializeCriticalSection(&m_csListItem);

    if (!m_wndToolBar.Create(this, WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_TOOLTIPS) ||
												!m_wndToolBar.LoadToolBar(IDR_TOOLBAR1))
    {
		TRACE("Toolbar create error\n");
		return -1;		// 쐬ɎsA߂l -1 ƂȂ܂B
    }
	m_IniFileName = GetIniFileName(AfxGetApp()->m_pszAppName, _T("ini"), 
												buf, (int)sizeof(buf)/sizeof(buf[0]));

	GetModuleDir(buf, sizeof(buf));
	m_sModuleDir = buf;

	//INIt@Cǂݍ
	LoadIniFile();

	InitDialog();

	//ݒt@CzXgǂݍ
	m_HostArray.RemoveAll();
	count = 0;

	for (i = 0; i < (int)m_MaxHostNum; i++) {
		int	flg = 0;
		int	mask = 0;

		memset(&info, 0, sizeof(info));

		sec.Format("HOST_%d", i);
		GetPrivateProfileString(sec, "HOST_NAME", "",
						info.hostname, sizeof(info.hostname), (LPCTSTR)m_IniFileName);
		if (info.hostname[0]) {
			flg |= 1;
		}
		GetPrivateProfileString(sec, "COMMENT", "",
						info.comment, sizeof(info.comment), (LPCTSTR)m_IniFileName);
		if (info.comment[0]) {
			flg |= 2;
		}
		GetPrivateProfileString(sec, "IP_ADDR", "",
						info.ipaddr, sizeof(info.ipaddr), (LPCTSTR)m_IniFileName);
		if (info.ipaddr[0]) {
			flg |= 4;
			mask |= 4;
		}
		GetPrivateProfileString(sec, "NET_MASK", "",
						info.netmask, sizeof(info.netmask), (LPCTSTR)m_IniFileName);
		if (info.ipaddr[0]) {
			flg |= 8;
		}
		GetPrivateProfileString(sec, "MAC_ADDR", "",
						info.macaddr, sizeof(info.macaddr), (LPCTSTR)m_IniFileName);
		if (info.macaddr[0]) {
			flg |= 0x10;
		}
		if (!(flg & mask)) {
			continue;
		}
		m_HostArray.Add(info);

		count++;
	}
	//zXgꗗɃzXgZbg
	RefreshHostList();

	//ftHg̃zXgݒ肳ĂΑIԂɂ
	if (GetPrivateProfileString("SETTING", "DEFAULT_HOST", "",
							buf, sizeof(buf), (LPCTSTR)m_IniFileName) > 0) {
		idx = atoi(buf);
		if (idx >= 0 && idx < count) {
			m_ListHosts.SetItemState(idx, LVIS_SELECTED, LVIS_SELECTED);
			m_SelHostName = m_ListHosts.GetItemText(idx, LIST_ITEM_HOST_NAME);
			m_SelComment = m_ListHosts.GetItemText(idx, LIST_ITEM_COMMENT);
			m_SelIpAddr = m_ListHosts.GetItemText(idx, LIST_ITEM_IP_ADDR);
			m_SelNetMask = m_ListHosts.GetItemText(idx, LIST_ITEM_NET_MASK);
			m_SelMacAddr = m_ListHosts.GetItemText(idx, LIST_ITEM_MAC_ADDR);
		}
	}
	ToolBarItemEnable();

	UpdateData(FALSE);

	m_hWorkEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	m_bWorkActive = TRUE;
	m_hWorkThread = CreateThread(NULL, 0, WorkThreadFunc, this, 0, NULL);

	//XV̗LEݒ
	EnableAutoRefresh(m_bAutoRefresh);

	//Vbg_ER}hB
	if (!m_bEnableRemoteShutdown) {
		CMenu			*pMenu = GetMenu();
		CMenu			*pSubMenu = pMenu->GetSubMenu(3);
		
		//j[Vbg_E̍ڂ̑ÕZp[^폜
		idx = SearchMenuPos(pSubMenu, ID_TOOL_SHUTDOWN);
		if (idx > 0) {
			pSubMenu->DeleteMenu(idx - 1, MF_BYPOSITION);
		}
		//j[Vbg_E̍ڂ폜
		pSubMenu->DeleteMenu(ID_TOOL_SHUTDOWN, MF_BYCOMMAND);
	}
	//1b̃^C}Zbg
	//m_TimerID = SetTimer(TIMER_ID_GENERAL, 1000, NULL);

	//c[`bv\̃^C}Zbg
	//m_TipTimerID = SetTimer(TIMER_ID_TIPS, 1000, NULL);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CWinWolDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	TRACE("CWinWolDlg::OnDestroy() Start\n");

	// TODO: ɃbZ[W nh[ R[hǉ܂B
	if (m_TimerID) {
		KillTimer(m_TimerID);
		m_TimerID = 0;
	}
	if (m_RefreshTimerID) {
		KillTimer(m_RefreshTimerID);
		m_RefreshTimerID = 0;
	}
	Sleep(1000);

	if (m_hWorkThread) {
		m_bWorkActive = FALSE;
		SetEvent(m_hWorkEvent);
		WaitForSingleObject(m_hWorkThread, INFINITE);
		m_hWorkThread = NULL;
	}
	TRACE("CWinWolDlg::OnDestroy() WorkThread End\n");

	//ݒt@Cɐݒlۑ
	SaveIniFile();

	DeleteCriticalSection(&m_csCollect);
	DeleteCriticalSection(&m_csRefresh);
	DeleteCriticalSection(&m_csListItem);

	TRACE("CWinWolDlg::OnDestroy() End\n");
}

void CWinWolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		ToolBarItemEnable();

		if ((nID & 0xFFF0) == SC_CLOSE) {
			CDialog::OnOK();
		} else if ((nID & 0xFFF0) == SC_MOUSEMENU || (nID & 0xFFF0) == SC_KEYMENU) {
			CMenu	*pMenu, *pSubMenu;
			int		sel_count = m_ListHosts.GetSelectedCount();
			int		itm_count = m_ListHosts.GetItemCount();

			pMenu = GetMenu();
			pSubMenu = pMenu->GetSubMenu(1);
			if (sel_count > 0) {
				pSubMenu->EnableMenuItem(ID_EDIT_APPEND, MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_INSERT, MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_EDIT,   MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_DELETE, MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_CUT,    MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_COPY,   MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_PASTE,  MF_BYCOMMAND | MF_ENABLED);
				if (sel_count < itm_count) {
					pSubMenu->EnableMenuItem(ID_EDIT_SELECT_ALL, MF_BYCOMMAND | MF_ENABLED);
				} else {
					pSubMenu->EnableMenuItem(ID_EDIT_SELECT_ALL, MF_BYCOMMAND | MF_DISABLED);
				}
			} else {
				pSubMenu->EnableMenuItem(ID_EDIT_APPEND,     MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_INSERT,     MF_BYCOMMAND | MF_DISABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_EDIT,       MF_BYCOMMAND | MF_DISABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_DELETE,     MF_BYCOMMAND | MF_DISABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_CUT,        MF_BYCOMMAND | MF_DISABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_COPY,       MF_BYCOMMAND | MF_DISABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_PASTE,      MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_EDIT_SELECT_ALL, MF_BYCOMMAND | MF_ENABLED);
			}
			pSubMenu = pMenu->GetSubMenu(2);
			if (sel_count > 0) {
				pSubMenu->EnableMenuItem(ID_VIEW_REFRESH, MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_VIEW_CHECK,   MF_BYCOMMAND | MF_ENABLED);
			} else {
				pSubMenu->EnableMenuItem(ID_VIEW_REFRESH, MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_VIEW_CHECK,   MF_BYCOMMAND | MF_DISABLED);
			}
			if (m_RefreshTimerID) {
				pSubMenu->EnableMenuItem(ID_VIEW_PERIOD_START, MF_BYCOMMAND | MF_DISABLED);
				pSubMenu->EnableMenuItem(ID_VIEW_PERIOD_STOP,  MF_BYCOMMAND | MF_ENABLED);
			} else {
				pSubMenu->EnableMenuItem(ID_VIEW_PERIOD_START, MF_BYCOMMAND | MF_ENABLED);
				pSubMenu->EnableMenuItem(ID_VIEW_PERIOD_STOP,  MF_BYCOMMAND | MF_DISABLED);
			}

			pSubMenu = pMenu->GetSubMenu(3);
			if (sel_count > 0) {
				pSubMenu->EnableMenuItem(ID_TOOL_SEND, MF_BYCOMMAND | MF_ENABLED);
				if (m_bEnableRemoteShutdown) {
					pSubMenu->EnableMenuItem(ID_TOOL_SHUTDOWN, MF_BYCOMMAND | MF_ENABLED);
				}
			} else {
				pSubMenu->EnableMenuItem(ID_TOOL_SEND, MF_BYCOMMAND | MF_DISABLED);
				if (m_bEnableRemoteShutdown) {
					pSubMenu->EnableMenuItem(ID_TOOL_SHUTDOWN, MF_BYCOMMAND | MF_DISABLED);
				}
			}
		}
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

//|bvAbvj[̕\ݒ
void CWinWolDlg::OnNMRClickListHost(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
    CMenu    *pMenu = NULL;
    CMenu    PopMenu;
    int      err = 0;
    
    // j[[h
    if (!PopMenu.LoadMenu(IDR_MENU2)) {
		return;
	}
    // Tuj[擾
    if (!(pMenu = PopMenu.GetSubMenu(0))) {
		PopMenu.DestroyMenu();
		return;
	}
	int	sel_count = m_ListHosts.GetSelectedCount();
	int	itm_count = m_ListHosts.GetItemCount();

	if (!m_bEnableRemoteShutdown) {
		int	idx;

		//j[Vbg_E̍ڂ̈ʒu擾
		idx = SearchMenuPos(pMenu, ID_TOOL_SHUTDOWN);
		if (idx > 0) {
			pMenu->DeleteMenu(idx - 1, MF_BYPOSITION);
		}
		//j[Vbg_E̍ڂ폜
		pMenu->DeleteMenu(ID_TOOL_SHUTDOWN, MF_BYCOMMAND);
	}
	if (sel_count > 0) {
		pMenu->EnableMenuItem(ID_EDIT_APPEND,  MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_INSERT,  MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_EDIT,    MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_DELETE,  MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_CUT,     MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_COPY,    MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_PASTE,   MF_BYCOMMAND | MF_ENABLED);
		if (sel_count < itm_count) {
			pMenu->EnableMenuItem(ID_EDIT_SELECT_ALL, MF_BYCOMMAND | MF_ENABLED);
		} else {
			pMenu->EnableMenuItem(ID_EDIT_SELECT_ALL, MF_BYCOMMAND | MF_DISABLED);
		}
		pMenu->EnableMenuItem(ID_VIEW_REFRESH, MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_VIEW_CHECK,   MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_TOOL_SEND,    MF_BYCOMMAND | MF_ENABLED);
	} else {
		pMenu->EnableMenuItem(ID_EDIT_APPEND,     MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_INSERT,     MF_BYCOMMAND | MF_DISABLED);
		pMenu->EnableMenuItem(ID_EDIT_EDIT,       MF_BYCOMMAND | MF_DISABLED);
		pMenu->EnableMenuItem(ID_EDIT_DELETE,     MF_BYCOMMAND | MF_DISABLED);
		pMenu->EnableMenuItem(ID_EDIT_CUT,        MF_BYCOMMAND | MF_DISABLED);
		pMenu->EnableMenuItem(ID_EDIT_COPY,       MF_BYCOMMAND | MF_DISABLED);
		pMenu->EnableMenuItem(ID_EDIT_PASTE,      MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_EDIT_SELECT_ALL, MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_VIEW_REFRESH,    MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_VIEW_CHECK,      MF_BYCOMMAND | MF_DISABLED);
		pMenu->EnableMenuItem(ID_TOOL_SEND,       MF_BYCOMMAND | MF_DISABLED);
	}
	if (m_RefreshTimerID) {
		pMenu->EnableMenuItem(ID_VIEW_PERIOD_START, MF_BYCOMMAND | MF_DISABLED);
		pMenu->EnableMenuItem(ID_VIEW_PERIOD_STOP,  MF_BYCOMMAND | MF_ENABLED);
	} else {
		pMenu->EnableMenuItem(ID_VIEW_PERIOD_START, MF_BYCOMMAND | MF_ENABLED);
		pMenu->EnableMenuItem(ID_VIEW_PERIOD_STOP,  MF_BYCOMMAND | MF_DISABLED);
	}

    // j[|bvAbv
	CPoint	pos;

	pos.x = pNMItemActivate->ptAction.x;
	pos.y = pNMItemActivate->ptAction.y;

    ClientToScreen(&pos);
    if (!pMenu->TrackPopupMenu(TPM_LEFTBUTTON, pos.x, pos.y, this)) {
		PopMenu.DestroyMenu();
		return;
    }
    // j[j
    PopMenu.DestroyMenu();

	*pResult = 0;
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CWinWolDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();

		if (!m_bInited) {
			if (m_bInitRefresh) {
				// 쒆̃zXgɃ}[N\
				RefreshStart();
			}
			m_bInited = TRUE;
		}
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CWinWolDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CWinWolDlg::OnOK()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB

//	CDialogEx::OnOK();
}


void CWinWolDlg::OnCancel()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	//ESCL[ōڂ̑I
	if (m_ListHosts.GetSelectedCount() > 0) {
		int cnt, i; 

		cnt = m_ListHosts.GetItemCount();
		for (i = 0; i < cnt; i++) {
			m_ListHosts.SetItemState(i, 0, LVIS_SELECTED);
		}
	}
//	CDialogEx::OnCancel();
}


void CWinWolDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialogEx::OnSize(nType, cx, cy);

	// TODO: ɃbZ[W nh[ R[hǉ܂B
	if (::IsWindow(GetSafeHwnd()) && IsWindowVisible()) {
        // Xe[^Xo[̃TCY擾
		CRect	rect_st;
		CRect	rect_cl;
		CRect	rect;
		CSize	tb_sz, st_sz;
		int		nwork;
		int		edge = GetSystemMetrics(SM_CXEDGE) * 4;

		// ݂̃NCAgEBhE
		// TCY擾
		GetClientRect(&rect_cl);

	    //  c[o[̍擾
		tb_sz = m_wndToolBar.CalcFixedLayout(FALSE, TRUE);

	    //  쐬͑傫0Ȃ̂Őݒ肷
		m_wndToolBar.MoveWindow( 0, 0, rect_cl.Width(), tb_sz.cy );

		st_sz = m_wndStatusBar.CalcFixedLayout(FALSE, TRUE);

		m_ListHosts.GetWindowRect(&rect);
		ScreenToClient(&rect);

		m_ListHosts.MoveWindow(rect.left, rect.top,
								rect_cl.right - (rect.left * 2),
								rect_cl.bottom - (rect.top + st_sz.cy + edge));

		// ێȂTCYύX
		nwork = st_sz.cy + edge;
		rect_st.top = rect_cl.bottom - nwork;
		rect_st.bottom = rect_st.top + nwork;
		rect_st.left = rect_cl.left;
		rect_st.right = rect_cl.right;

		m_wndStatusBar.MoveWindow(rect_st);
    }	
}

//c[`bv̕\ƃXg̐擪ACẽACR̃Cfg𒲐邽
BOOL CWinWolDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	LPNMHDR pNMHDR = (LPNMHDR)lParam;
	UINT	nID = (UINT)wParam;

	//Xg̐擪̕ύXꂽ̂ŃACR̃Cfg𒲐
	if (pNMHDR->code == HDN_ENDTRACKA || pNMHDR->code == HDN_BEGINTRACKW ||
			pNMHDR->code == HDN_DIVIDERDBLCLICKA || pNMHDR->code == HDN_DIVIDERDBLCLICKW) {
		LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
		if (phdr->iItem == LIST_ITEM_ACTIVE) {
			if (m_nActiveMarkType == ACTIVE_MARK_TYPE_ICON) {
				//ACR̃CfgbZ[Wŗv
				PostMessage(WM_WOL_WIN_MSG, (WPARAM)WOL_MSG_COL_WIDTH_CHANGE, (LPARAM)0);
			}
		}
	}
	//c[`bvƃXe[^Xo[ւ̕\
	switch (pNMHDR->code) {
	case TTN_GETDISPINFO:
		{ 
			LPTOOLTIPTEXT	lpttt; 
			BOOL			bSet = FALSE;
			CString			str;

			lpttt = (LPTOOLTIPTEXT) lParam; 
			lpttt->hinst = AfxGetApp()->m_hInstance;

			switch (lpttt->hdr.idFrom) { 
			case ID_EDIT_APPEND:
				str.LoadString(ID_EDIT_APPEND);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_APPEND);
				bSet = TRUE;
				break; 
			case ID_EDIT_INSERT: 
				str.LoadString(ID_EDIT_INSERT);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_INSERT); 
				bSet = TRUE;
				break; 
			case ID_EDIT_EDIT: 
				str.LoadString(ID_EDIT_EDIT);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_EDIT); 
				bSet = TRUE;
				break; 
			case ID_EDIT_DELETE: 
				str.LoadString(ID_EDIT_DELETE);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_DELETE); 
				bSet = TRUE;
				break; 
			case ID_EDIT_CUT: 
				str.LoadString(ID_EDIT_CUT);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_CUT); 
				bSet = TRUE;
				break; 
			case ID_EDIT_COPY: 
				str.LoadString(ID_EDIT_COPY);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_COPY); 
				bSet = TRUE;
				break; 
			case ID_EDIT_PASTE: 
				str.LoadString(ID_EDIT_PASTE);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_PASTE); 
				bSet = TRUE;
				break; 
			case ID_EDIT_UP:
				str.LoadString(ID_EDIT_UP);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_UP); 
				bSet = TRUE;
				break; 
			case ID_EDIT_DOWN:
				str.LoadString(ID_EDIT_DOWN);
				lpttt->lpszText = MAKEINTRESOURCE(ID_EDIT_DOWN); 
				bSet = TRUE;
				break; 
			case ID_VIEW_REFRESH: 
				str.LoadString(ID_VIEW_REFRESH);
				lpttt->lpszText = MAKEINTRESOURCE(ID_VIEW_REFRESH); 
				bSet = TRUE;
				break; 
			case ID_VIEW_CHECK: 
				str.LoadString(ID_VIEW_CHECK);
				lpttt->lpszText = MAKEINTRESOURCE(ID_VIEW_CHECK); 
				bSet = TRUE;
				break; 
			case ID_VIEW_PERIOD_START:
				str.LoadString(ID_VIEW_PERIOD_START);
				lpttt->lpszText = MAKEINTRESOURCE(ID_VIEW_PERIOD_START); 
				bSet = TRUE;
				break;
			case ID_VIEW_PERIOD_STOP:
				str.LoadString(ID_VIEW_PERIOD_STOP);
				lpttt->lpszText = MAKEINTRESOURCE(ID_VIEW_PERIOD_STOP); 
				bSet = TRUE;
				break;
			case ID_TOOL_SEND: 
				str.LoadString(ID_TOOL_SEND);
				lpttt->lpszText = MAKEINTRESOURCE(ID_TOOL_SEND); 
				bSet = TRUE;
				break;
			default:
				break;
			}
			if (bSet) {
				DispStatusMsg(str);
			}
		}
		break;
	}
	return CDialogEx::OnNotify(wParam, lParam, pResult);
}

//_CAOx[X̃AvŃANZ[^L[Lɂ邽߂ɕKv
BOOL CWinWolDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	if (TranslateAccelerator(GetSafeHwnd(), m_Accel, pMsg)) {
		return TRUE;
	}
	return CDialogEx::PreTranslateMessage(pMsg);
}

//Xg̐擪ڂł̃c[`bvƃXe[^Xo[ւ̕\
void CWinWolDlg::OnLvnGetInfoTipListHost(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVGETINFOTIP*pInfoTip = reinterpret_cast<NMLVGETINFOTIP*>(pNMHDR);

	if (pInfoTip) {
		CString	str;
		TCHAR	buf[1024];

		str.LoadString(IDS_STRING_DBL_CLICK_FOR_ACTIVE);

		_tcsncpy_s(buf, str, _TRUNCATE);

		DispStatusMsg(str);

		pInfoTip->pszText = buf;
	
		*pResult = 0;
	}
}

void CWinWolDlg::OnLvnItemchangedListHost(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B

	ToolBarItemEnable();

	*pResult = 0;
}

//XgŃ_uNbNƂ̏
void CWinWolDlg::OnNMDblclkListHost(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if (!pNMItemActivate) {
		*pResult = -1;
		return;
	}
	int	idx = pNMItemActivate->iItem;

	if (pNMItemActivate->iSubItem == 0) {
		CWaitCursor	csr;

		if (SendMagicPacketToListItem(idx, TRUE)) {
			CString		str;

			str.Format("%d", idx);
			WritePrivateProfileString("SETTING", "DEFAULT_HOST",
											(LPCTSTR)str, (LPCTSTR)m_IniFileName);

			RefreshStart();
			ToolBarItemEnable();
		}
	} else {
		if (!EditHost(idx)) {
			*pResult = -1;
			return;
		}
		ToolBarItemEnable();
	}
	*pResult = 0;
}

void CWinWolDlg::OnAppExit()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CDialog::OnCancel();
}


void CWinWolDlg::OnEditAppend()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CHostEditDlg	dlg;
	int				cnt;
	CString			str;

	if (m_bCollectActive) {
		return;
	}
	// IĂzXg̃lbg}XNftHgƂ
	cnt = m_ListHosts.GetItemCount();
	if (cnt >= (int)m_MaxHostNum) {
		str.LoadString(IDS_STRING_OVER_MAX_HOST_NUM);
		MessageBox(str);
		return;
	}
	if (!m_SelNetMask.IsEmpty()) {
		dlg.SetNetMask((LPCTSTR)m_SelNetMask);
	}
	if (dlg.DoModal() == IDOK) {
		LV_ITEM		lvitem;
		tHostInfo	info;

		memset(&lvitem, 0, sizeof(lvitem));

		m_SelHostName = dlg.GetHostName();
		m_SelComment = dlg.GetComment();
		m_SelIpAddr = dlg.GetIpAddr();
		m_SelNetMask = dlg.GetNetMask();
		m_SelMacAddr = dlg.GetMacAddr();

		strcpy_s(info.hostname, sizeof(info.hostname), (LPCTSTR)m_SelHostName);
		strcpy_s(info.comment, sizeof(info.comment), (LPCTSTR)m_SelComment);
		strcpy_s(info.ipaddr, sizeof(info.ipaddr), (LPCTSTR)m_SelIpAddr);
		strcpy_s(info.netmask, sizeof(info.netmask), (LPCTSTR)m_SelNetMask);
		strcpy_s(info.macaddr, sizeof(info.macaddr), (LPCTSTR)m_SelMacAddr);

		info.active = 0;

		if (m_nActiveMarkType == ACTIVE_MARK_TYPE_ICON) {
			lvitem.mask = LVIF_STATE | LVIF_INDENT;
			lvitem.iItem = cnt;
			lvitem.iSubItem = LIST_ITEM_ACTIVE;
			lvitem.pszText = "";
			lvitem.iIndent = (m_nColWidth[LIST_ITEM_ACTIVE] - LIST_ICON_WIDTH) / 2;
			lvitem.stateMask = LVIS_STATEIMAGEMASK;
			lvitem.state = INDEXTOSTATEIMAGEMASK(INACTIVE_IMAGE_IDX);
		} else {
			lvitem.mask = LVIF_TEXT;
			lvitem.iItem = cnt;
			lvitem.iSubItem = LIST_ITEM_ACTIVE;
			lvitem.pszText = "";
		}
		EnterCriticalSection(&m_csListItem);

		m_ListHosts.InsertItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = cnt;
		lvitem.iSubItem = LIST_ITEM_HOST_NAME;
		lvitem.pszText = info.hostname;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = cnt;
		lvitem.iSubItem = LIST_ITEM_COMMENT;
		lvitem.pszText = info.comment;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = cnt;
		lvitem.iSubItem = LIST_ITEM_IP_ADDR;
		lvitem.pszText = info.ipaddr;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = cnt;
		lvitem.iSubItem = LIST_ITEM_NET_MASK;
		lvitem.pszText = info.netmask;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = cnt;
		lvitem.iSubItem = LIST_ITEM_MAC_ADDR;
		lvitem.pszText = info.macaddr;
		m_ListHosts.SetItem(&lvitem);

		m_HostArray.Add(info);

		LeaveCriticalSection(&m_csListItem);

		// 쒆̃zXgɃ}[N\
		RefreshAliveHost(cnt);
		RefreshAliveMark(cnt);
	}
	ToolBarItemEnable();
}

void CWinWolDlg::OnEditInsert()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CHostEditDlg	dlg;
	int				i, cnt, idx;
	CString			str;

	if (m_bCollectActive) {
		return;
	}
	if (m_ListHosts.GetSelectedCount() > 1) {
		str.LoadString(IDS_STRING_SELECT_ONE_ITEM);
		MessageBox(str);
		return;
	}
	cnt = m_ListHosts.GetItemCount();
	if (cnt >= (int)m_MaxHostNum) {
		str.LoadString(IDS_STRING_OVER_MAX_HOST_NUM);
		MessageBox(str);
		return;
	}
	idx = cnt;
	for (i = 0; i < cnt; i++) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			idx = i;
			break;
		}
	}
	// IĂzXg̃lbg}XNftHgƂ
	if (!m_SelNetMask.IsEmpty()) {
		dlg.SetNetMask((LPCTSTR)m_SelNetMask);
	}

	if (dlg.DoModal() == IDOK) {
		LV_ITEM		lvitem;
		tHostInfo	info;

		memset(&lvitem, 0, sizeof(lvitem));

		m_SelHostName = dlg.GetHostName();
		m_SelComment = dlg.GetComment();
		m_SelIpAddr = dlg.GetIpAddr();
		m_SelNetMask = dlg.GetNetMask();
		m_SelMacAddr = dlg.GetMacAddr();

		strcpy_s(info.hostname, sizeof(info.hostname), (LPCTSTR)m_SelHostName);
		strcpy_s(info.comment, sizeof(info.comment), (LPCTSTR)m_SelComment);
		strcpy_s(info.ipaddr, sizeof(info.ipaddr), (LPCTSTR)m_SelIpAddr);
		strcpy_s(info.netmask, sizeof(info.netmask), (LPCTSTR)m_SelNetMask);
		strcpy_s(info.macaddr, sizeof(info.macaddr), (LPCTSTR)m_SelMacAddr);

		info.active = 0;

		if (m_nActiveMarkType == ACTIVE_MARK_TYPE_ICON) {
			lvitem.mask = LVIF_STATE | LVIF_INDENT;
			lvitem.iItem = idx;
			lvitem.iSubItem = LIST_ITEM_ACTIVE;
			lvitem.pszText = "";
			lvitem.iIndent = (m_nColWidth[LIST_ITEM_ACTIVE] - LIST_ICON_WIDTH) / 2;
			lvitem.stateMask = LVIS_STATEIMAGEMASK;
			lvitem.state = INDEXTOSTATEIMAGEMASK(INACTIVE_IMAGE_IDX);
		} else {
			lvitem.mask = LVIF_TEXT;
			lvitem.iItem = idx;
			lvitem.iSubItem = LIST_ITEM_ACTIVE;
			lvitem.pszText = "";
		}
		EnterCriticalSection(&m_csListItem);

		m_ListHosts.InsertItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = idx;
		lvitem.iSubItem = LIST_ITEM_HOST_NAME;
		lvitem.pszText = info.hostname;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = idx;
		lvitem.iSubItem = LIST_ITEM_COMMENT;
		lvitem.pszText = info.comment;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = idx;
		lvitem.iSubItem = LIST_ITEM_IP_ADDR;
		lvitem.pszText = info.ipaddr;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = idx;
		lvitem.iSubItem = LIST_ITEM_NET_MASK;
		lvitem.pszText = info.netmask;
		m_ListHosts.SetItem(&lvitem);

		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = idx;
		lvitem.iSubItem = LIST_ITEM_MAC_ADDR;
		lvitem.pszText = info.macaddr;
		m_ListHosts.SetItem(&lvitem);

		m_HostArray.InsertAt(idx, info);
	
		LeaveCriticalSection(&m_csListItem);

		// 쒆̃zXgɃ}[N\
		RefreshAliveHost(idx);
		RefreshAliveMark(idx);
	}
	ToolBarItemEnable();
}

void CWinWolDlg::OnEditEdit()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int				i, cnt, idx;
	CHostEditDlg	dlg;
	CString			str;

	if (m_bCollectActive) {
		return;
	}
	UpdateData(TRUE);

	if (m_ListHosts.GetSelectedCount() > 1) {
		str.LoadString(IDS_STRING_SELECT_ONE_ITEM);
		MessageBox(str);
		return;
	}
	idx = -1;
	cnt = m_ListHosts.GetItemCount();
	for (i = 0; i < cnt; i++) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			idx = i;
			break;
		}
	}
	if (idx < 0) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	EditHost(idx);

	ToolBarItemEnable();
}

void CWinWolDlg::OnEditDelete()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int		i, cnt, sel_cnt;
	CString	str;
	CString	sIpAddr;
	CString	sHostName;

	if (m_bCollectActive) {
		return;
	}
	if ((sel_cnt = m_ListHosts.GetSelectedCount()) < 1) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	cnt = m_ListHosts.GetItemCount();
	if (sel_cnt > 1) {
		str.LoadStringA(IDS_STRING_DELETE_ASK);
		if (MessageBox((LPCTSTR)str, NULL, MB_YESNO) != IDYES) {
			return;
		}
	}
	EnterCriticalSection(&m_csListItem);

	for (i = cnt - 1; i >= 0; i--) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			if (sel_cnt == 1) {
				sHostName = m_ListHosts.GetItemText(i, LIST_ITEM_HOST_NAME);
				sIpAddr = m_ListHosts.GetItemText(i, LIST_ITEM_IP_ADDR);

				CString	tmp;
				tmp.LoadStringA(IDS_STRING_IS_DELETE);
				str.Format("%s(%s) %s", (LPCTSTR)sHostName, (LPCTSTR)sIpAddr, tmp);
				if (MessageBox((LPCTSTR)str, NULL, MB_YESNO) != IDYES) {
					continue;
				}
			}
			m_ListHosts.DeleteItem(i);
			m_HostArray.RemoveAt(i);
		}
	}
	LeaveCriticalSection(&m_csListItem);

	// 쒆̃zXgɃ}[N\
	//RefreshStart();

	ToolBarItemEnable();
}

void CWinWolDlg::OnEditUp()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int				i, cnt, idx;
	CString			str;

	if (m_bCollectActive) {
		return;
	}
	if ((cnt = m_ListHosts.GetSelectedCount()) > 1) {
		str.LoadString(IDS_STRING_SELECT_ONE_ITEM);
		MessageBox(str);
		return;
	} else if (cnt <= 0) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	idx = -1;
	cnt = m_ListHosts.GetItemCount();
	for (i = 0; i < cnt; i++) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			idx = i;
			break;
		}
	}
	if (idx < 0) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	ListItemUp(idx);

	ToolBarItemEnable();
}


void CWinWolDlg::OnEditDown()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int				i, cnt, idx;
	CString			str;

	if (m_bCollectActive) {
		return;
	}
	if ((cnt = m_ListHosts.GetSelectedCount()) > 1) {
		str.LoadString(IDS_STRING_SELECT_ONE_ITEM);
		MessageBox(str);
		return;
	} else if (cnt <= 0) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	idx = -1;
	cnt = m_ListHosts.GetItemCount();
	for (i = 0; i < cnt; i++) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			idx = i;
			break;
		}
	}
	if (idx < 0) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	ListItemDown(idx);

	ToolBarItemEnable();
}


void CWinWolDlg::OnEditCut()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int					i, cnt, idx;
	CString				str;
	CString				sHostName, sComment, sIpAddr, sNetMask, sMacAddr;
	CString				sBuf("");
	UINT				uiState;
	CArray<int, int>	idxArr;
	BOOL				bUpdate = FALSE;

	if (m_bCollectActive) {
		return;
	}
	if ((cnt = m_ListHosts.GetSelectedCount()) <= 0) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	idxArr.RemoveAll();

	cnt = m_ListHosts.GetItemCount();
	for (i = 0; i < cnt; i++) {
		if ((uiState = m_ListHosts.GetItemState(i, LVIS_SELECTED))) {
			idxArr.Add(i);
			sHostName = m_ListHosts.GetItemText(i, LIST_ITEM_HOST_NAME);
			sComment = m_ListHosts.GetItemText(i, LIST_ITEM_COMMENT);
			sIpAddr = m_ListHosts.GetItemText(i, LIST_ITEM_IP_ADDR);
			sNetMask = m_ListHosts.GetItemText(i, LIST_ITEM_NET_MASK);
			sMacAddr = m_ListHosts.GetItemText(i, LIST_ITEM_MAC_ADDR);
			str.Format("%s,%s,%s,%s,%s", sHostName, sComment, sIpAddr, sNetMask, sMacAddr);
			if (!sBuf.IsEmpty()) {
				sBuf += "\n";
			}
			sBuf += str;
		}
	}
	if (!sBuf.IsEmpty()) {
		::SetToClipBoard(sBuf);
	}
	EnterCriticalSection(&m_csListItem);

	cnt = idxArr.GetCount();
	for (i = cnt - 1; i >= 0; i--) {
		idx = idxArr[i];
		m_HostArray.RemoveAt(idx);
	}
	idxArr.RemoveAll();

	LeaveCriticalSection(&m_csListItem);

	if (cnt > 0) {
		RefreshHostList();
		RefreshStart();
	}
}

void CWinWolDlg::OnEditCopy()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int			i, cnt;
	CString		str;
	CString		sHostName, sComment, sIpAddr, sNetMask, sMacAddr;
	CString		sBuf("");
	UINT		uiState;

	if (m_bCollectActive) {
		return;
	}
	if ((cnt = m_ListHosts.GetSelectedCount()) <= 0) {
		str.LoadString(IDS_STRING_SELECT_HOST);
		MessageBox(str);
		return;
	}
	cnt = m_ListHosts.GetItemCount();
	for (i = 0; i < cnt; i++) {
		if ((uiState = m_ListHosts.GetItemState(i, LVIS_SELECTED))) {
			sHostName = m_ListHosts.GetItemText(i, LIST_ITEM_HOST_NAME);
			sComment = m_ListHosts.GetItemText(i, LIST_ITEM_COMMENT);
			sIpAddr = m_ListHosts.GetItemText(i, LIST_ITEM_IP_ADDR);
			sNetMask = m_ListHosts.GetItemText(i, LIST_ITEM_NET_MASK);
			sMacAddr = m_ListHosts.GetItemText(i, LIST_ITEM_MAC_ADDR);
			str.Format("%s,%s,%s,%s,%s", sHostName, sComment, sIpAddr, sNetMask, sMacAddr);
			if (!sBuf.IsEmpty()) {
				sBuf += "\n";
			}
			sBuf += str;
			//uiState &= ~LVIS_SELECTED;
			m_ListHosts.SetItemState(i, 0, LVIS_SELECTED);
		}
	}
	if (!sBuf.IsEmpty()) {
		::SetToClipBoard(sBuf);
	}
}


void CWinWolDlg::OnEditPaste()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int		cnt;
	CString	str;
	int		len;
	LPTSTR	pClipData;
	int		i, idx = -1;

	if (m_bCollectActive) {
		return;
	}
	cnt = m_ListHosts.GetItemCount();
	for (i = 0; i < cnt; i++) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			idx = i;
			break;
		}
	}
	if (idx < 0) {
		idx = cnt;
	}
	if ((len = GetFromClipBoard(&pClipData)) <= 0) {
		str.LoadString(IDS_STRING_NO_PASTE_DATA);
		MessageBox(str);
		return;
	} else {
		TCHAR			*pBuf, *p;
		BOOL			bUnMatchData = FALSE;
		BOOL			bUpdate = FALSE;
		int				start_idx = idx;
		unsigned char	maddr[6];
		tHostInfo		info;

		EnterCriticalSection(&m_csListItem);

		pBuf = pClipData;
		while (pBuf && *pBuf) {
			if (!(*pBuf) || !(p = strchr(pBuf, ','))) {
				bUnMatchData = TRUE;
				break;
			}
			*p = NULL;
			strcpy_s(info.hostname, sizeof(info.hostname), pBuf);

			pBuf = p + 1;
			if (!(*pBuf) || !(p = strchr(pBuf, ','))) {
				bUnMatchData = TRUE;
				break;
			}
			*p = NULL;
			strcpy_s(info.comment, sizeof(info.comment), pBuf);

			pBuf = p + 1;
			if (!(*pBuf) || !(p = strchr(pBuf, ','))) {
				bUnMatchData = TRUE;
				break;
			}
			*p = NULL;
			if (*pBuf && StrToDwIpAddr(pBuf) == INADDR_NONE) {
				bUnMatchData = TRUE;
				break;
			}
			strcpy_s(info.ipaddr, sizeof(info.ipaddr), pBuf);

			pBuf = p + 1;
			if (!(*pBuf) || !(p = strchr(pBuf, ','))) {
				bUnMatchData = TRUE;
				break;
			}
			*p = NULL;
			if (*pBuf && StrToDwIpAddr(pBuf) == INADDR_NONE) {
				bUnMatchData = TRUE;
				break;
			}
			strcpy_s(info.netmask, sizeof(info.netmask), pBuf);

			pBuf = p + 1;
			if (*pBuf) {
				if ((p = strchr(pBuf, '\n'))) {
					*p = NULL;
				}
				if (StrMacAddrToBin(pBuf, maddr) != 0) {
					bUnMatchData = TRUE;
					break;
				}
			}
			strcpy_s(info.macaddr, sizeof(info.macaddr), pBuf);

			m_HostArray.InsertAt(idx, info);
			idx++;

			bUpdate = TRUE;

			if (p) {
				pBuf = p + 1;
			} else {
				pBuf = NULL;
			}
		}
		LeaveCriticalSection(&m_csListItem);

		ReleaseClipBoardData(pClipData);

		if (bUnMatchData) {
			str.LoadString(IDS_STRING_PASTE_DATA_UNMATCH);
			MessageBox(str);

		}
		if (bUpdate) {
			RefreshHostList();
			for (i = start_idx; i < idx; i++) {
				m_ListHosts.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);
			}
			RefreshStart();
		}
	}
}

void CWinWolDlg::OnEditSelectAll()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int		cnt, i;

	if (m_bCollectActive) {
		return;
	}
	cnt = m_ListHosts.GetItemCount();
	for (i = 0; i < cnt; i++) {
		m_ListHosts.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);
	}
}

void CWinWolDlg::OnViewRefresh()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CWaitCursor	wait;

	// 쒆̃zXgɃ}[N\
	RefreshStart();

	ToolBarItemEnable();
}

void CWinWolDlg::OnViewCheck()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CWaitCursor	csr;
	int			cnt = m_ListHosts.GetItemCount();

	for (int i = 0; i < cnt; i++) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			RefreshAliveHost(i);
		}
	}
}

void CWinWolDlg::OnViewPeriodStart()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	EnableAutoRefresh(TRUE);
}


void CWinWolDlg::OnViewPeriodStop()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	EnableAutoRefresh(FALSE);
}

void CWinWolDlg::OnToolSend()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	WakeupHosts(TRUE);
}

void CWinWolDlg::OnToolSendNonBloadcast()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	WakeupHosts(FALSE);
}

void CWinWolDlg::OnToolOption()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	COptionDlg	dlg(this);
	tOption		data;

	data.uiTimeOut = m_TimeOut;
	data.uiPortNo = m_PortNo;
	data.uiMaxHostNum = m_MaxHostNum;
	data.bInitRefresh = m_bInitRefresh;
	data.bNoExternCmd = m_bNoExternCmd;
	data.bCheckNetworkSegment = m_bCheckNetworkSegment;
	data.bAutoRefresh = m_bAutoRefresh;
	data.uiTimerInterval = m_TimerInterval;
	data.ActiveFgColor = m_ActiveFgColor;
	data.ActiveBgColor = m_ActiveBgColor;
	data.nActiveMarkType = m_nActiveMarkType;
	data.sActiveMarkStr = m_sAvtiveMark;

	dlg.SetData(data);
	if (dlg.DoModal() == IDOK) {
		dlg.GetData(data);

		m_TimeOut = data.uiTimeOut;
		m_PortNo = data.uiPortNo;
		m_MaxHostNum = data.uiMaxHostNum;
		m_bInitRefresh = data.bInitRefresh;
		m_bNoExternCmd = data.bNoExternCmd;
		m_bCheckNetworkSegment = data.bCheckNetworkSegment;
		m_bAutoRefresh = data.bAutoRefresh;
		m_TimerInterval = data.uiTimerInterval;
		m_ActiveFgColor = data.ActiveFgColor;
		m_ActiveBgColor = data.ActiveBgColor;
		m_sAvtiveMark = data.sActiveMarkStr;

		if (data.nActiveMarkType != m_nActiveMarkType) {
			ChangeActiveIconType(data.nActiveMarkType);
		}
		//XV̗LEݒ
		EnableAutoRefresh(m_bAutoRefresh);

		RefreshStart();
	}
}


void CWinWolDlg::OnToolGetIpAddr()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CGetIpDlg	dlg;

	if (m_ListHosts.GetSelectedCount() > 0) {
		int	count = m_ListHosts.GetItemCount();
		for (int i = 0; i < count; i++) {
			if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
				dlg.m_SrchHostName = m_ListHosts.GetItemText(i, LIST_ITEM_HOST_NAME);
				break;
			}
		}
	}
	if (dlg.DoModal() == IDOK) {
	}
}


void CWinWolDlg::OnToolGetMacAddr()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CGetMacAddrDlg	dlg;

	if (m_ListHosts.GetSelectedCount() > 0) {
		int	count = m_ListHosts.GetItemCount();
		for (int i = 0; i < count; i++) {
			if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
				dlg.m_Host = m_ListHosts.GetItemText(i, LIST_ITEM_IP_ADDR);
				if (dlg.m_Host.IsEmpty()) {
					dlg.m_Host = m_ListHosts.GetItemText(i, LIST_ITEM_HOST_NAME);
				}
				break;
			}
		}
	}
	dlg.SetTimeOut(m_TimeOut);
	if (dlg.DoModal() == IDOK) {
	}
}



void CWinWolDlg::OnToolGetHost()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CGetHostDlg	dlg;

	if (m_ListHosts.GetSelectedCount() > 0) {
		int	count = m_ListHosts.GetItemCount();
		for (int i = 0; i < count; i++) {
			if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
				dlg.m_IpAddr = m_ListHosts.GetItemText(i, LIST_ITEM_IP_ADDR);
				break;
			}
		}
	}
	if (dlg.DoModal() == IDOK) {
	}
}

#if 0
void CWinWolDlg::OnToolRegChange()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CString	msg, cap;
	
	msg.LoadString(IDS_STRING_REG_CHANGE_MSG);
	cap.LoadString(IDS_STRING_REG_CHANGE_CAPTION);

	if (MessageBox(msg, cap, MB_OKCANCEL) == IDOK) {
		if (SetRegistory()) {
			msg.LoadString(IDS_STRING_REG_CHANGE_RES_OK);
		} else {
			msg.LoadString(IDS_STRING_REG_CHANGE_RES_NG);
		}
		MessageBox(msg);
	}
}
#endif


void CWinWolDlg::OnToolSendIcmp()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	CSendIcmpDlg	dlg(this);

	if (m_ListHosts.GetSelectedCount() > 0) {
		int	count = m_ListHosts.GetItemCount();
		for (int i = 0; i < count; i++) {
			if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
				dlg.m_Host = m_ListHosts.GetItemText(i, LIST_ITEM_IP_ADDR);
				if (dlg.m_Host.IsEmpty()) {
					dlg.m_Host = m_ListHosts.GetItemText(i, LIST_ITEM_HOST_NAME);
				}
				break;
			}
		}
	}
	if (dlg.DoModal() == IDOK) {
		//ɉȂ
	}
}

//zXgWJn
void CWinWolDlg::OnToolCollectHostInfo()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	DWORD		dwIpAddr, dwStartAddr, dwEndAddr, dwNetMask;
	UINT		nTimeOut;
	CString		strMsg, strCaption;
	int			res;
	TCHAR		buf[64];
	
	if ((dwIpAddr = GetDwMyIpAddr()) == 0) {
		strMsg.LoadString(IDS_STRING_GET_HOST_ADDR_ERROR);
		MessageBox(strMsg);
		return;
	}
	dwStartAddr = 0;
	dwEndAddr = 0;
	dwNetMask = 0;

	//zXgW̊JnAhX
	if (!m_sCollectHostStart.IsEmpty()) {
		dwStartAddr = StrToDwIpAddr((LPCTSTR)m_sCollectHostStart);
	}
	//zXgW̏IAhX
	if (!m_sCollectHostEnd.IsEmpty()) {
		dwEndAddr = StrToDwIpAddr((LPCTSTR)m_sCollectHostEnd);
	}
	//zXgW̃lbg}XN
	if (!m_sCollectHostNetMask.IsEmpty()) {
		dwNetMask = StrToDwIpAddr((LPCTSTR)m_sCollectHostNetMask);
	} else {
		//IPAhXftHg̃lbg}XN𐶐
		dwNetMask = GetDefaultNetMask(dwIpAddr);
	}
	if (dwStartAddr == 0) {
		// IPAhXƃlbg}XNJnAhX𐶐
		dwStartAddr = dwIpAddr & dwNetMask;
		dwStartAddr++;			//擪̓lbg[NAhXȂ̂łPZ
	}
	if (dwEndAddr == 0) {
		// IPAhXƃlbg}XNIAhX𐶐
		dwEndAddr = dwIpAddr | ~dwNetMask;
		dwEndAddr--;			//Ō̓u[hLXgAhXȂ̂łPĂ
	}
	CCollectHostDlg	dlg;

	dlg.SetRange(dwStartAddr, dwEndAddr);
	dlg.SetNetMask(dwNetMask);
	dlg.SetTimeOut(m_CollectHostTimeOut);
	if (dlg.DoModal() != IDOK) {
		return;
	}
	dlg.GetRange(dwStartAddr, dwEndAddr);
	dwNetMask = dlg.GetNetMask();
	nTimeOut = dlg.GetTimeOut();

	if (dwStartAddr > dwEndAddr) {
		DWORD	dwTmp = dwStartAddr;
		dwStartAddr = dwEndAddr;
		dwEndAddr = dwTmp;
	}
	strCaption.LoadString(IDS_STRING_COLLECT_IP_ADDR);
	strMsg.LoadString(IDS_STRING_COLLECT_HOST_ASK);

	if ((res = MessageBox(strMsg, strCaption, MB_YESNO)) != IDYES) {
		return;
	}
	m_sCollectHostStart = DwToStrIpAddr(dwStartAddr, buf, sizeof(buf)/sizeof(buf[0]));
	m_sCollectHostEnd = DwToStrIpAddr(dwEndAddr, buf, sizeof(buf)/sizeof(buf[0]));

	m_nCollectDetectCount = 0;

	m_dwCollectStartAddr = m_dwCollectCurrentAddr = dwStartAddr;
	m_dwCollectEndAddr = dwEndAddr;
	m_dwCollectNetMask = dwNetMask;
	m_CollectHostTimeOut = nTimeOut;

	m_pCollectProcDlg =	new CCollectProcDlg(this);
	m_pCollectProcDlg->SetRange(0, dwEndAddr - dwStartAddr + 1);
	m_pCollectProcDlg->ShowWindow(SW_SHOW);

	m_nCursorType = WOL_CURSOR_TYPE_WAIT;

	m_hCollectEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	m_hCollectThread = CreateThread(NULL, 0, CollectThreadFunc, this, 0, NULL);

//	SetThreadPriority(m_hCollectThread, THREAD_PRIORITY_BELOW_NORMAL);
	SetThreadPriority(m_hCollectThread, THREAD_PRIORITY_IDLE);
}

void CWinWolDlg::OnToolShutdown()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	int cnt = m_ListHosts.GetItemCount();
	if (cnt > 0) {
		CString	msg;
		msg.LoadString(IDS_STRING_SHUTDOWN_NOTIFY);
		if (MessageBox(msg, NULL, MB_YESNO) != IDYES) {
			return;
		}
	}
	for (int i = 0; i < cnt; i++) {
		if (m_ListHosts.GetItemState(i, LVIS_SELECTED)) {
			ShutDownWindowsHost(i);
		}
	}
}

void CWinWolDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	if (nIDEvent == m_TimerID) {
		//̂Ƃ돈͂Ȃ;
	} else if (nIDEvent == m_RefreshTimerID) {
		RefreshStart(FALSE);
	} else if (nIDEvent == m_TipTimerID) {
#if 0
		if (m_nTipTimeOut > 0) {
			m_nTipTimeOut--;
			if (m_nTipTimeOut == 0) {
				DispStatusMsg("");
			}
		}
#endif
	}
	CDialogEx::OnTimer(nIDEvent);
}

void CWinWolDlg::OnNMCustomdrawListHost(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	LPNMLVCUSTOMDRAW	pLVCD = (LPNMLVCUSTOMDRAW)pNMCD;
	CString				str;

	switch (pNMCD->dwDrawStage) {
	case CDDS_PREPAINT:
		// eACe̕`掞ɒʒmv
		*pResult = CDRF_NOTIFYITEMDRAW;
		break;
	case CDDS_ITEMPREPAINT:
        // eTuACe̕`掞ɒʒmv
        *pResult = CDRF_NOTIFYSUBITEMDRAW;
		break;
	case (CDDS_ITEMPREPAINT | CDDS_SUBITEM):
		// eTuACe̕`
		if (pLVCD->iSubItem == 0) {
			CString	str = m_ListHosts.GetItemText(pNMCD->dwItemSpec, pLVCD->iSubItem);
			if (str.GetLength() > 0) {
				pLVCD->clrTextBk = m_ActiveBgColor;
				pLVCD->clrText = m_ActiveFgColor;
			} else {
				pLVCD->clrTextBk = GetSysColor(COLOR_WINDOW);
				pLVCD->clrText = GetSysColor(COLOR_WINDOWTEXT);
			}
		} else {
			pLVCD->clrTextBk = GetSysColor(COLOR_WINDOW);
			pLVCD->clrText = GetSysColor(COLOR_WINDOWTEXT);
		}
		*pResult = CDRF_NEWFONT;
		break;
	default:
		*pResult = 0;			
		break;
	}
}

//[U[`̃bZ[WEnh
LRESULT	CWinWolDlg::OnWakeOnLanWinMsg(WPARAM wParam, LPARAM lParam)
{
	char	szIpAddr[32];
	CString	strMsg;

	switch ((int)wParam) {
	case WOL_MSG_REPAINT:
		//ƃXbh̍ĕ`v
		if (!m_bCollectActive) {
			RefreshAliveMark(-1);
			DispStatusMsg("");
		}
		break;
	case WOL_MSG_COL_WIDTH_CHANGE:
		RefreshActiveIconIndent();
		break;
	case WOL_MSG_COLLECT_HOST:
		DwToStrIpAddr((DWORD)lParam, szIpAddr, sizeof(szIpAddr));
		strMsg.Format("Check IP Address %s", szIpAddr);
		DispStatusMsg(strMsg);
		if (m_pCollectProcDlg) {
			int nPos = (int)((DWORD)lParam - m_dwCollectStartAddr);
			m_pCollectProcDlg->SetPos(nPos);
			m_pCollectProcDlg->SetText(szIpAddr);
		}
		break;
	case WOL_MSG_DETECT_HOST:
		if (m_pCollectProcDlg) {
			m_pCollectProcDlg->SetCount((int)lParam);
		}
		break;
	case WOL_MSG_COLLECT_MSG:
		switch ((int)lParam) {
		case 0:
			m_pCollectProcDlg->DestroyWindow();
			m_nCursorType = WOL_CURSOR_TYPE_NORMAL;
			DispStatusMsg("");
			break;
		case 1:
			m_pCollectProcDlg->DestroyWindow();
			m_nCursorType = WOL_CURSOR_TYPE_NORMAL;
			DispStatusMsg("");
			RefreshHostList();
			RefreshStart();
			break;
		case -1:
			strMsg.LoadString(IDS_STRING_CANT_USE_ICMP);
			MessageBox(strMsg);
			break;
		case -2:
			strMsg.LoadString(IDS_STRING_HOST_COLLECT_CANCEL);
			MessageBox(strMsg);
			break;
		}
		break;
	case WOL_MSG_CLEAR_STATUS:
		DispStatusMsg("");
		break;
	default:
		break;
	}
	return 0;
}

//zXgW󋵃_CAO̒fbZ[W
LRESULT	CWinWolDlg::OnCollectProcMsg(WPARAM wParam, LPARAM lParam)
{
	SetCollectActiveFlag(FALSE);

	return 0;
}

BOOL CWinWolDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B
	if (m_nCursorType == WOL_CURSOR_TYPE_WAIT) {
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
		return  TRUE;
	} else if (m_nCursorType == WOL_CURSOR_TYPE_WAIT_ARROW) {
		::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_APPSTARTING));
		return  TRUE;
	}
	return CDialogEx::OnSetCursor(pWnd, nHitTest, message);
}
